#
# process_ansible_parameters.rb
#
# Description: Process Ansible parameters into ws_values hash
#
# ltdoux@tva.gov June 2017
#

begin
  @debug = true
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  $evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
  request = $evm.root['miq_provision_request']
  prov = $evm.root["miq_provision"]
  
  # Collect info from other dialogs.
  environment =  $evm.root['dialog_tag_1_environment'].first.name rescue nil
  $evm.log(:info, "environment: #{environment}") if @debug
  role =  $evm.root['dialog_tag_1_role'].first.name rescue nil
  $evm.log(:info, "role: #{role}") if @debug
  city =  $evm.root['dialog_tag_1_city'].first.name rescue nil
  $evm.log(:info, "city: #{city}") if @debug
  replicated =  $evm.root['dialog_tag_1_replicated'].first.name rescue nil
  $evm.log(:info, "replicated: #{replicated}") if @debug
  cluster = $evm.root['dialog_option_1_cluster_name']
  $evm.log(:info, "cluster: #{cluster}") if @debug
  exit MIQ_OK if environment.blank? || role.blank? || city.blank? || replicated.blank?

  # Set LDAP info

  # If sandbox, point to RHDS 10 dev environment
  if environment == "sandbox"
      prov.options[:ws_values] = {:ldap_server_list=>"['itdsd2.main.tva.gov','itdsd1.main.tva.gov']", :ldap_uri_list=>"['ldap://itdsd2.main.tva.gov/','ldap://itdsd1.main.tva.gov/']"}
  elsif city == "knx"
      prov.options[:ws_values] = {:ldap_server_list=>"['itdsp4.main.tva.gov','itdsp2.main.tva.gov','itdsp3.main.tva.gov','itdsp1.main.tva.gov']", :ldap_uri_list=>"['ldap://itdsp4.main.tva.gov/','ldap://itdsp2.main.tva.gov/','ldap://itdsp3.main.tva.gov/','ldap://itdsp1.main.tva.gov/']"}
  else
      prov.options[:ws_values] = {:ldap_server_list=>"['itdsp2.main.tva.gov','itdsp4.main.tva.gov','itdsp1.main.tva.gov','itdsp3.main.tva.gov']", :ldap_uri_list=>"['ldap://itdsp2.main.tva.gov/','ldap://itdsp4.main.tva.gov/','ldap://itdsp1.main.tva.gov/','ldap://itdsp3.main.tva.gov/']"}
  end

  
rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
