#
# apd_get_cluster.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  vcenter = $evm.root['dialog_option_1_vcenter'] rescue nil
  $evm.log(:info, "vcenter: #{vcenter}") if @debug
  datacenter = $evm.root['dialog_option_1_datacenter'] rescue nil
  $evm.log(:info, "datacenter: #{datacenter}") if @debug
  exit MIQ_OK if vcenter.blank? || datacenter.blank?
  
  case vcenter
    when "CHAPVDIVC2"
      case datacenter
        when "VDI Datacenter"
          c = ["CHA VDI Cluster 04"]
        when "XenApp"
          c = ["CHA XenApp Cluster 01","CHA XenApp Cluster 02","KNX XenApp Cluster 01","CHA XenDesktop Legacy"]
    end
    when "CHAPWVDIVC01"
      case datacenter
        when "Chattanooga VDI"
          c = ["CHA Spares","CHA XenDesktop","CHA XenApp"]
        when "Knoxville VDI"
          c = ["KNX XenDesktop","KNX Spares","KNX XenApp"]
    end
  else
    c = $evm.vmdb(:ems).find_by_name("#{vcenter}").ems_clusters.collect {|cluster| cluster.name if cluster.v_parent_datacenter == "#{datacenter}"}.uniq
  end
    $evm.log(:info, "Cluster_names: #{c}") if @debug
    clusters = Hash[ *c.compact.collect { |v| [ v, v.gsub('%2f','/') ] }.flatten ]
    clusters[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      clusters
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
