#
# apd_get_datacenters.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  vcenter = $evm.root['dialog_option_1_vcenter'] rescue nil
  $evm.log(:info, "vcenter: #{vcenter}") if @debug
  exit MIQ_OK if vcenter.blank?
  
  case vcenter
    when "CHAPVDIVC2"
    d = ["VDI Datacenter","XenApp"]
    when "CHAPWVDIVC01"
    d = ["Chattanooga VDI","Knoxville VDI"]
    else
    d = $evm.vmdb(:ems).find_by_name("#{vcenter}").ems_clusters.collect {|cluster| cluster.v_parent_datacenter}.uniq
  end
  $evm.log(:info, "Datacenter_names: #{d}") if @debug
  datacenters = Hash[ *d.compact.collect { |v| [ v, v.gsub('%2f','/') ] }.flatten ]
  datacenters[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      datacenters
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
