#
# get_azure_info.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug

  require 'net/http'
  require 'json'

  #Collect information from dialogs
  size = $evm.root['dialog_option_1_vmSize'] rescue nil
  exit MIQ_OK if size.blank?

  url = "http://chapwcouchdb1.main.tva.gov:5984/azurevmsizes/_design/vmsizes/_view/vmsizes?key=\"#{size}\"" 
  uri = URI(url)
  response = Net::HTTP.get(uri)
  couch = JSON.parse response
  c={}
  couch['rows'].each { |x| c = x['value'].fetch('Cores') }
  m={}
  couch['rows'].each { |x| m = x['value'].fetch('Memory') }
  d={}
  couch['rows'].each { |x| d = x['value'].fetch('Drives') }
  i={}
  couch['rows'].each { |x| i = x['value'].fetch('MaxIOPS') }
  o={}
  couch['rows'].each { |x| o = x['value'].fetch('OSDriveSize') }
  r={}
  couch['rows'].each { |x| r = x['value'].fetch('ResourceDriveSize') }

  info = "CPU Cores:#{c}\nMemory:#{m}\nDrives:#{d}\nMaxIOPs:#{i}\nOSDriveSize:#{o}\nResourceDriveSize:#{r}\nPricing:https://azure.microsoft.com/en-us/pricing/calculator/"
  $evm.log(:info, "Info: #{info}") if @debug

  list_values = {
    'required' => true,
    'protected' => false,
    'read_only' => true,
    'value' => info,
  }
  list_values.each do |key, value|
  $evm.object[key] = value
  end
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
  
