#
# get_azure_offer.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
  require 'net/http'
  require 'json'

  #Collect information from dialogs
  publisher = $evm.root['dialog_option_2_Publisher'] rescue nil
  $evm.log(:info, "Publisher: #{publisher}") if @debug
  exit MIQ_OK if publisher.blank?

  url = "http://chapwcouchdb1.main.tva.gov:5984/azurecatalog/_design/catalog/_view/offers?key=\"#{publisher}\"" 
  uri = URI(url)
  response = Net::HTTP.get(uri)
  couch = JSON.parse response
  o = couch['rows'].collect { |x| x['value']}.uniq
  $evm.log(:info, "Offer_names: #{o}") if @debug
  offer = Hash[ *o.collect { |v| [ v, v ] }.flatten ]
  offer[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      offer
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
