#
# get_azure_sku.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
  
  require 'net/http'
  require 'json'

  #Collect information from dialogs 
  offer = $evm.object['dialog_option_1_Offer'] rescue nil
  $evm.log(:info, "Offer: #{offer}") if @debug
  exit MIQ_OK if offer.blank?

  url = "http://chapwcouchdb1.main.tva.gov:5984/azurecatalog/_design/catalog/_view/skus?key=\"#{offer}\"" 
  uri = URI(url)
  response = Net::HTTP.get(uri)
  couch = JSON.parse response
  s = couch['rows'].collect { |x| x['value']}.uniq
  $evm.log(:info, "SKU_names: #{s}") if @debug
  sku = Hash[ *s.collect { |v| [ v, v ] }.flatten ]
  sku[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      sku
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end

