begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug

  require 'net/http'
  require 'json'
  
  #Collect information from dialogs
  server = $evm.object['dialog_server']
  $evm.log(:info, "Server: #{server}") if @debug
  $evm.object['read_only'] = true
  exit MIQ_OK if server.blank?
  
  url = "http://knxdwcouchdb1.main.tva.gov:5984/arpcloudvms/_design/arpcloud/_view/vmFind" 
  uri = URI(url)
  response = Net::HTTP.get(uri)
  couch = JSON.parse response
  c ={}
  couch['rows'].collect { |x| c =x['value'].fetch('state') if x['value'].fetch('server') == server }
  $evm.log(:info, "State: #{c}") if @debug

  list_values = {
   'required' => true,
   'protected' => false,
   'read_only' => true,
   'value' => c,
  }
  list_values.each do |key, value|
  $evm.object[key] = value
  end
end
