#
# get_cluster.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  vcenter = $evm.root['dialog_option_1_vcenter'] rescue nil
  $evm.log(:info, "vcenter: #{vcenter}") if @debug
  datacenter = $evm.root['dialog_option_1_datacenter']
  datacenter ||= $evm.root['dialog_option_1_datacentername']
  $evm.log(:info, "datacenter: #{datacenter}") if @debug
  exit MIQ_OK if vcenter.blank? || datacenter.blank?

  c = $evm.vmdb(:ems).find_by_name("#{vcenter}").ems_clusters.collect {|cluster| cluster.name if cluster.v_parent_datacenter == "#{datacenter}" && cluster.name != "Management Cluster"}.uniq
  $evm.log(:info, "Cluster_names: #{c}") if @debug
  clusters = Hash[ *c.compact.collect { |v| [ v, v.gsub('%2f','/') ] }.flatten ]
  clusters[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      clusters
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
