#
# get_cluster.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  cluster = $evm.root['dialog_Cluster'] rescue nil
  $evm.log(:info, "Cluster: #{cluster}") if @debug
  exit MIQ_OK if cluster.blank?

  d = $evm.vmdb(:ems_cluster).find_by_name("#{cluster}").storages.collect { |storage| storage.name } 
  $evm.log(:info, "Datastore_names: #{d}") if @debug
  datastores = Hash[ *d.compact.collect { |v| [ v, v ] }.flatten ]
  datastores[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      datastores
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
