#
# get_slots.rb
#
# Description: <Method description here>
#

begin
  @debug = true
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  
  require 'net/http'
  require 'json'
  
  
  #Collect information from dialogs
  webapp = $evm.root['dialog_app_name'] rescue nil
  $evm.log(:info, "WebApp: #{webapp}") if @debug
  exit MIQ_OK if webapp.blank?
  
  url = "http://chapwcouchdb1.main.tva.gov:5984/azureappservices/_design/AppServices/_view/Slots?key=\"#{webapp}\""
  uri = URI(url)
  response = Net::HTTP.get(uri)
  couch = JSON.parse response
  slots = couch['rows'].collect { |x| x['value']}.uniq.flatten
  $evm.log(:info, "Slots: #{slots}") if @debug
  slots = Hash[ *slots.collect { |v| [ v, v ] }.flatten ]
  slots[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      slots

rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
