#
# get_vm.rb
#
# Description: <Method description here>
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  vm_name = $evm.root['vm']
  $evm.log(:info, "VMName: #{vm_name}") if @debug
  exit MIQ_OK if vm_name.blank?
  
  s = $evm.vmdb(:vm).find_by_name("#{vm_name}").snapshots.collect {|snapshot| snapshot.name }.uniq
  $evm.log(:info, "Sanpshot_names: #{s}") if @debug
  snapshots = {}
  if s.blank?
    snapshots[''] = 'No Snapshots found'
  else
    snapshots = Hash[ *s.compact.collect { |v| [ v, v ] }.flatten ]
    snapshots[''] = '<Choose>'
  end
  
  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      snapshots
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
