#
# list_pools.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug

  require 'net/http'
  require 'json'

  array_name = $evm.root['dialog_SANarray'] rescue nil
  $evm.log(:info, "SANarray: #{array_name}") if @debug
  exit MIQ_OK if array_name.blank?

  url = "http://chapwcouchdb1.main.tva.gov:5984/lunprovisioning/_design/array/_view/pools?key=\"#{array_name}\"" 
  uri = URI(url)
  response = Net::HTTP.get(uri)
  couch = JSON.parse response
  h = couch['rows'].collect { |x| x['value'].fetch('Pool') }
  p = h[0].collect { |x| x.fetch('PoolID') }
  $evm.log(:info, "PoolID: #{p}") if @debug
  pool_id = Hash[ *p.collect { |v| [ v, v ] }.flatten ]
  pool_id[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      pool_id
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
