#
# on_prem_name.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug

  require 'net/http'
  require 'json'
  
  #Collect information from dialogs
  template = $evm.root['dialog_option_1_Template']
  $evm.log(:info, "Template: #{template}") if @debug
#  if template.blank?
#    $evm.object['visible'] = false
#  else
#    $evm.object['visible'] = true
#  end
  exit MIQ_OK if template.blank?

  url = "http://chapwcouchdb1.main.tva.gov:5984/arpcloudcatalog/_design/catalog/_view/templates?key=\"#{template}\""
  uri = URI(url)
  response = Net::HTTP.get(uri)
  couch = JSON.parse response
  r={}
  couch['rows'].each { |x| r=x['value'].fetch('Regex') }
  $evm.log(:info, "Regex: #{r}") if @debug

  case r
    when 'Maximo'
      name = 'MAX'
      rx_validator = '^[M][A][X][A-Za-z0-9\-\_]{1,40}$'     
    when 'ECM'
      name = 'OT'
      rx_validator = '^[O][T][A-Z0-9-]{3,13}$' 
    when 'Citrix7'
      name = 'VRA-WIN7-'
      rx_validator = '^[V][R][A][-][W][I][N][7][-][A-Z0-9]{1,6}$'
    when 'Citrix10'
      name = 'VRA-WINX-'
      rx_validator = '^[V][R][A][-][W][I][N][X][-][A-Z0-9]{1,6}$'
    when 'ARPcloud'
      name = 'CHATW'
      rx_validator = '^[C][H][A][T][W][A-za-z0-9-_]{1,10}$'  
  end
  $evm.log(:info, "Name: #{name}") if @debug
  $evm.log(:info, "Validator: #{rx_validator}") if @debug
 
  list_values = {
    'required' => true,
    'validator_type' => 'regex',
    'validator_rule' => rx_validator,
    'protected' => false,
    'read_only' => false,
    'value' => name,
  }
  list_values.each do |key, value|
  $evm.object[key] = value
  end
end
