#
# windows_deploy_name.rb
#
# Description: <Method description here>
#

begin
  @debug = true
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  
  datacenter_name = $evm.root['dialog_option_1_datacentername']
  $evm.log(:info, "datacenter_name: #{datacenter_name}")
  cluster_name = $evm.root['dialog_option_1_clustername']
  $evm.log(:info, "cluster_name: #{cluster_name}")
  environment = $evm.root['dialog_environment']
  $evm.log(:info, "Environment: #{environment}")
  vplex =  $evm.root['dialog_option_1_vplex']
  $evm.log(:info, "vplex: #{vplex}") 
  exit MIQ_OK if datacenter_name.blank? || cluster_name.blank? || environment.blank? || vplex.blank?
  
  cluster = $evm.vmdb(:ems_cluster).find_by_name(cluster_name)
  raise "cluster #{cluster_name} not found!" if cluster.blank?
  $evm.log(:info, "cluster: #{cluster.name}") if @debug
  
  if datacenter_name == 'Unified Datacenter T-BLOCK' && vplex == 'Yes'
    city = $evm.root['dialog_city']
    rx_validator = "^#{city}#{environment}[W][0-9,A-Z]{0,10}$"
    exit MIQ_OK if city.blank?
  elsif datacenter_name == 'Unified Datacenter T-BLOCK' && vplex == 'No'
    city = $evm.root['dialog_city']
    if city == 'UDC'
       city = 'CHA'
    else
       city = 'KNX'
    end
    rx_validator = "^#{city}#{environment}[W][0-9,A-Z]{0,10}$"
    exit MIQ_OK if city.blank?
  else
    host = cluster.hosts.select {|host| host.power_state == 'on'}.first unless cluster.blank?
    city = host.name[0..2].upcase
    rx_validator = "^#{city}#{environment}[W][0-9,A-Z]{0,10}$"
  end
  $evm.log(:info, "City: #{city}") if @debug
  
  list_values = {
    'required' => true,
    'validator_type' => 'regex',
    'validator_rule' => rx_validator,
    'protected' => false,
    'read_only' => false,
    'value' => "#{city}#{environment}W",
  }
  list_values.each do |key, value|
  $evm.object[key] = value
  end
end  
