#
# get_adusers.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
   
  require 'rubygems' 
  require 'net/ldap'
  
  #Collect information from dialogs
  host = $evm.object['hostname'] rescue nil
  $evm.log(:info, "host: #{host}") if @debug
  username = $evm.object['username'] rescue nil
  $evm.log(:info, "username: #{username}") if @debug
  password = $evm.object.decrypt('password') rescue nil
  param = 'IT'
  $evm.log(:info, "param: #{param}") if @debug
  port = '389' 
  $evm.log(:info, "port: #{port}") if @debug
  base = 'OU=Main,DC=main,DC=tva,DC=gov'
  $evm.log(:info, "base: #{base}") if @debug
  
  exit MIQ_OK if  param.blank? || host.blank? || username.blank? || password.blank?

  credentials = { 
       :method => :simple, 
       :username => username, 
       :password => password
  }

  $evm.log(:info, "Initiating a ldap connection") if @debug
  conn = Net::LDAP.new(:host => host, :port => port, :base => base, :auth => credentials)
  search_filter = Net::LDAP::Filter.eq("physicalDeliveryOfficeName", param)
  #search_filter = Net::LDAP::Filter.eq("sAMAccountName", param)
  key = []
  value = []
  $evm.log(:info, "Performing ldap search operation") if @debug
  conn.search(:filter => search_filter, :attributes => ["sAMAccountName", "DisplayName"]) do |item| 
    if item.sAMAccountName.first !~ /-wa/i  
      key << item.sAMAccountName.first.to_s 
      value << item.DisplayName.first.to_s 
    end
  end
  hash = {}
  key.each_with_index {|k,i|hash[k] = value[i]}
  $evm.log(:info, "Users: #{hash}") if @debug
  hash[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      hash
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
