#
# members_validation.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
  
  if $evm.root['dialog_newGroup'] == 'Yes'
    $evm.object['visible'] = true
    $evm.object['read_only'] = true
    $evm.object['value'] = 'Click refresh to validate'
  else
    $evm.object['visible'] = false
  end
  
  require 'rubygems' 
  require 'net/ldap'
  
  #Collect information from dialogs
  host = $evm.object['hostname'] rescue nil
  $evm.log(:info, "host: #{host}") if @debug
  username = $evm.object['username'] rescue nil
  $evm.log(:info, "username: #{username}") if @debug
  password = $evm.object.decrypt('password') rescue nil
  param = $evm.root['dialog_members'].split(',') rescue nil
  $evm.log(:info, "param: #{param}") if @debug
  port = '389' 
  $evm.log(:info, "port: #{port}") if @debug
  base = 'OU=Main,DC=main,DC=tva,DC=gov'
  $evm.log(:info, "base: #{base}") if @debug
  rx_validator = '^(Validated)$'
  
  exit MIQ_OK if  param.blank? || host.blank? || username.blank? || password.blank?

  credentials = { 
       :method => :simple, 
       :username => username, 
       :password => password
  }
  
  data = {}
  ntid = ''
  param.each do |n|
    $evm.log(:info, "Initiating a ldap connection") if @debug
    conn = Net::LDAP.new(:host => host, :port => port, :base => base, :auth => credentials)
    ntid = n
    search_filter = Net::LDAP::Filter.eq("sAMAccountName", n) 
    $evm.log(:info, "Performing ldap search operation") if @debug
    data = ''
    conn.search(:filter => search_filter, :attributes => "sAMAccountName") { |item| data = item.sAMAccountName.first.to_s }
    $evm.log(:info, "userid: #{data}") if @debug
    break if data.blank?
  end
  
  $evm.log(:info, "NTID: #{data}") if @debug
  if data.blank?
    status = "#{ntid} - Invalid NTID"
  else
    status = "Validated"
  end  

  list_values = {
    'required' => true,
    'protected' => false,
    'read_only' => true,
    'validator_type' => 'regex',
    'validator_rule' => rx_validator,
    'value' => status,
  }
  list_values.each do |key, value|
  $evm.object[key] = value
  end
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
