#
# Description: 
#

begin
  @debug = true

  require 'rubygems' 
  require 'net/ldap'
  
  #Collect information from dialogs
  host = $evm.object['hostname'] rescue nil
  $evm.log(:info, "host: #{host}") if @debug
  username = $evm.object['username'] rescue nil
  $evm.log(:info, "username: #{username}") if @debug
  password = $evm.object.decrypt('password') rescue nil
  port = '389' 
  $evm.log(:info, "port: #{port}") if @debug
  base = 'OU=Main,DC=main,DC=tva,DC=gov'
  $evm.log(:info, "base: #{base}") if @debug
  param = $evm.object['email'] rescue nil
  $evm.log(:info, "param: #{param}") if @debug

  exit MIQ_OK if  param.blank? || host.blank? || username.blank? || password.blank?
  
  credentials = { 
       :method => :simple, 
       :username => username, 
       :password => password
  }
  if param =~ /tva.gov/i
   # param = param.gsub(/main./, '')
    $evm.log(:info, "Initiating a ldap connection") if @debug
    conn = Net::LDAP.new(:host => host, :port => port, :base => base, :auth => credentials)
    $evm.log(:info, "LDAP search filter UserPrincipalName") if @debug
    search_filter = Net::LDAP::Filter.eq("UserPrincipalName", param) 
    ntid = ''
    $evm.log(:info, "Performing ldap search operation") if @debug
    conn.search(:filter => search_filter, :attributes => "sAMAccountName") { |item| ntid = item.sAMAccountName.first.to_s }
    $evm.log(:info, "NTID: #{ntid}") if @debug
    $evm.root['userid'] = ntid
  else  
    $evm.log(:info, "Initiating a ldap connection") if @debug
    conn = Net::LDAP.new(:host => host, :port => port, :base => base, :auth => credentials)
    $evm.log(:info, "LDAP search filter sAMAccountName") if @debug
    search_filter = Net::LDAP::Filter.eq("sAMAccountName", param) 
    ntid = ''
    $evm.log(:info, "Performing ldap search operation") if @debug
    conn.search(:filter => search_filter, :attributes => "sAMAccountName") { |item| ntid = item.sAMAccountName.first.to_s }
    $evm.log(:info, "NTID: #{ntid}") if @debug
    $evm.root['userid'] = ntid
  end
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
