#
# shiny_owner_validation.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
  
  require 'rubygems' 
  require 'net/ldap'
  
  #Collect information from dialogs
  host = $evm.object['hostname'] rescue nil
  $evm.log(:info, "host: #{host}") if @debug
  username = $evm.object['username'] rescue nil
  $evm.log(:info, "username: #{username}") if @debug
  password = $evm.object.decrypt('password') rescue nil
  param = $evm.root['dialog_business_owner'] rescue nil
  $evm.log(:info, "param: #{param}") if @debug
  port = '389' 
  $evm.log(:info, "port: #{port}") if @debug
  base = 'OU=Main,DC=main,DC=tva,DC=gov'
  $evm.log(:info, "base: #{base}") if @debug
  rx_validator = '^(Validated)$'
  
  exit MIQ_OK if  param.blank? || host.blank? || username.blank? || password.blank?

  credentials = { 
       :method => :simple, 
       :username => username, 
       :password => password
  }

  $evm.log(:info, "Initiating a ldap connection") if @debug
  conn = Net::LDAP.new(:host => host, :port => port, :base => base, :auth => credentials)
  search_filter = Net::LDAP::Filter.eq("sAMAccountName", param) 
  data = ''
  $evm.log(:info, "Performing ldap search operation") if @debug
  conn.search(:filter => search_filter, :attributes => "sAMAccountName") { |item| data = item.sAMAccountName.first.to_s }
  $evm.log(:info, "userid: #{data}") if @debug

  if data == ''
    status = "#{param} is not a valid userid"
    visibility = 'true'
    $evm.create_notification(:message => "Invalid UserID")
  else
    status = "Validated"
    visibility = 'false'
  end  

  list_values = {
    'required' => true,
    'protected' => false,
    'read_only' => true,
    'validator_type' => 'regex',
    'validator_rule' => rx_validator,
    'visible' => visibility,
    'value' => status,
  }
  list_values.each do |key, value|
  $evm.object[key] = value
  end
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
