#
# get_mdr_servers.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
   
  
  access = $evm.root['dialog_access'] rescue nil
  $evm.log(:info, "Access: #{access}") if @debug
  environment = $evm.root['dialog_environment'] rescue nil
  $evm.log(:info, "Environment: #{environment}") if @debug
  exit MIQ_OK if access.blank?
  
  if access == 'Machines'
    require 'pg'
  
    hostname = $evm.object['psql_hostname'] rescue nil
    $evm.log(:info, "Hostname: #{hostname}") if @debug
    username = $evm.object['psql_username'] rescue nil
    $evm.log(:info, "Username: #{username}") if @debug
    password = $evm.object.decrypt('psql_password') rescue nil

    conn = PG.connect( :host => "#{hostname}", :dbname => 'vmdb_production', :port => 5432, :user => "#{username}", :password => "#{password}")
    vms = conn.exec('select v.name from vms v join operating_systems o on v.id=o.vm_or_template_id where o.product_name like \'%Microsoft Windows Server 201%\' and v.ems_id in (10000000000003,10000000000004,10000000000006) and v.template=\'f\';').values
    conn.close
    valid_vms = vms.flatten.select { |vm| vm.to_s[3] =~ /#{environment[0]}/i}
    $evm.log(:info, "VM(s): #{valid_vms}") if @debug
    objects = Hash[ *valid_vms.compact.collect { |v| [ v, v] }.flatten ]
  else
    require 'rubygems' 
    require 'net/ldap'
  
    #Collect information from dialogs
    host = $evm.object['ldap_hostname'] rescue nil
    $evm.log(:info, "host: #{host}") if @debug
    username = $evm.object['ldap_username'] rescue nil
    $evm.log(:info, "username: #{username}") if @debug
    password = $evm.object.decrypt('ldap_password') rescue nil
    param = 'IT'
    $evm.log(:info, "param: #{param}") if @debug
    port = '389' 
    $evm.log(:info, "port: #{port}") if @debug
    base = 'OU=Main,DC=main,DC=tva,DC=gov'
    $evm.log(:info, "base: #{base}") if @debug
  
    credentials = { 
       :method => :simple, 
       :username => username, 
       :password => password
    }

    $evm.log(:info, "Initiating a ldap connection") if @debug
    conn = Net::LDAP.new(:host => host, :port => port, :base => base, :auth => credentials)
    search_filter = Net::LDAP::Filter.eq("physicalDeliveryOfficeName", param)
    key = []
    value = []
    $evm.log(:info, "Performing ldap search operation") if @debug
    conn.search(:filter => search_filter, :attributes => ["sAMAccountName", "DisplayName"]) do |item| 
      if item.sAMAccountName.first !~ /-wa/i  
        key << item.sAMAccountName.first.to_s 
        value << item.DisplayName.first.to_s 
      end
    end
    objects = {}
    key.each_with_index {|k,i|objects[k] = value[i]}
    $evm.log(:info, "Users: #{objects}") if @debug
  end
  objects[''] = '<Choose>'
  
    dialog_field                    =      $evm.object
    dialog_field["sort_by"]         =      "value"
    dialog_field["sort_order"]      =      "ascending"
    dialog_field["data_type"]       =      "string"
    dialog_field['default_value']   =      ''
    dialog_field["required"]        =      "true"
    dialog_field["values"]          =      objects
    
rescue => err
$evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
exit MIQ_ABORT
end
