#
# get_batch_patch_version.rb
#
# Description:
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug

  server_name = $evm.root['dialog_host_name']
  $evm.log(:info, "Servername: #{server_name}") if @debug
  oracle_version = $evm.root['dialog_ora_version']
  $evm.log(:info, "Oracle_Version: #{oracle_version}") if @debug
  product_name = $evm.root['dialog_ora_product']
  $evm.log(:info, "Product_Name: #{product_name}") if @debug
  exit MIQ_OK if server_name.blank? || oracle_version.blank? || product_name.blank?

  require 'oci8'
  hostname = $evm.object['hostname'] rescue nil
  $evm.log(:info, "Hostname: #{hostname}") if @debug
  username = $evm.object['username'] rescue nil
  $evm.log(:info, "Username: #{username}") if @debug
  password = $evm.object.decrypt('password') rescue nil

  q = []
  conn = OCI8.new("#{username}","#{password}","#{hostname}:1600/itsp")
  conn.exec("select distinct substr(patch_name, instr(patch_name, 'u') + 1) as patch from patching_parameters_vw order by 1") do |record|
    q << record.join(',')
  end
  conn.logoff
  $evm.log(:info, "Batch_Patch_Version: #{q}") if @debug
  batch_patch_version = Hash[ *q.compact.collect { |v| [ v, v] }.flatten ]
  batch_patch_version[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      batch_patch_version

  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
