#
# get_deployment_group.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
  require 'oci8'
  
  environment = $evm.root['dialog_env'] rescue nil
  $evm.log(:info, "Environment: #{environment}") if @debug
  exit MIQ_OK if environment.blank?
  
  username = $evm.object['username'] rescue nil
  $evm.log(:info, "Username: #{username}") if @debug
  password = $evm.object.decrypt('password') rescue nil

  g = []
  if environment == 'Production'
    hostname = 'pltdba2.main.tva.gov'
    $evm.log(:info, "Hostname: #{hostname}") if @debug
    conn = OCI8.new("#{username}","#{password}","#{hostname}:1600/infa10a")
    conn.exec('SELECT UPPER(DEP_GROUP_NAME) FROM INFAREP_ACCP.REP_DEPLOY_GROUP ORDER BY 1') do |record|
    g << record.join(',')
    end
  else
    hostname = 'pltdbd2.main.tva.gov'
    $evm.log(:info, "Hostname: #{hostname}") if @debug
    conn = OCI8.new("#{username}","#{password}","#{hostname}:1600/infa10d")
    conn.exec('SELECT UPPER(DEP_GROUP_NAME) FROM INFAREP_DEV.REP_DEPLOY_GROUP ORDER BY 1') do |record|
    g << record.join(',')
    end
  end
  conn.logoff
  $evm.log(:info, "Deployment Group Name: #{g}") if @debug
  group = Hash[ *g.compact.collect { |v| [ v, v] }.flatten ]
  group[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      group
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
