#
# get_maxref_dest_host.rb
#
# Description:
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
  require 'oci8'

  hostname = $evm.object['hostname'] rescue nil
  $evm.log(:info, "Hostname: #{hostname}") if @debug
  username = $evm.object['username'] rescue nil
  $evm.log(:info, "Username: #{username}") if @debug
  password = $evm.object.decrypt('password') rescue nil

  q = []
  conn = OCI8.new("#{username}","#{password}","#{hostname}:1600/itsp")
  conn.exec("select distinct v.host_name as host_name from oramaint.version v join oramaint.hosts_sids_by_type h on h.database_name = v.database_name where (v.host_name like 'mx%' or v.host_name like 'ggmx%') and h.type_code = 'T' order by 1") do |record|
    q << record.join(',')
  end
  conn.logoff
  $evm.log(:info, "Dest_Host: #{q}") if @debug
  dest_host = Hash[ *q.compact.collect { |v| [ v, v] }.flatten ]
  dest_host[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      dest_host

  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
