#
# get_maxref_dest_sid.rb
#
# Description:
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug

  server_name = $evm.root['dialog_destination_host']
  $evm.log(:info, "Servername: #{server_name}") if @debug
  exit MIQ_OK if server_name.blank?

  require 'oci8'
  hostname = $evm.object['hostname'] rescue nil
  $evm.log(:info, "Hostname: #{hostname}") if @debug
  username = $evm.object['username'] rescue nil
  $evm.log(:info, "Username: #{username}") if @debug
  password = $evm.object.decrypt('password') rescue nil

  q = []
  conn = OCI8.new("#{username}","#{password}","#{hostname}:1600/itsp")
  conn.exec("select distinct v.database_name from oramaint.version v join oramaint.hosts_sids_by_type h on h.database_name = v.database_name where v.database_name like 'mx%' and v.host_name='#{server_name}' and v.database_name not in ('mxldemo','mxldemo2','mxlsiba') order by 1") do |record|
    q << record.join(',')
  end
  $evm.log(:info, "Dest_Sid: #{q}") if @debug
  dest_sid = Hash[ *q.compact.collect { |v| [ v, v] }.flatten ]

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      q[0]
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      dest_sid

  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
