#
# get_maxref_export.rb
#
# Description: Collects the list of exports from the destination host.
#

begin
 hostname = $evm.root['dialog_destination_host'] rescue nil
 $evm.log(:info, "Destination Host: #{hostname}") if @debug 
 database = $evm.root['dialog_destination_database'] rescue nil
 $evm.log(:info, "Destination Database: #{database}") if @debug 
 type = $evm.root['dialog_export_type'] rescue nil
 $evm.log(:info, "ExportType: #{type}") if @debug
 exit MIQ_OK if hostname.blank? || database.blank? || type.blank?
  
 require 'rubygems'
 require 'net/ssh'
 
 username = $evm.object['username']
 password = $evm.object.decrypt('password')
 
 if type == 'current'
   cmd = "ls /u06/app/oracle/export_area/#{database}/dbaexp | grep [.]dmp | grep -v [.]gz | cut -f1 -d'.' | gawk '{print substr($0,1,length()-2)}' | uniq"
 else
   cmd = "ls /u06/app/oracle/export_area/#{database}/dbaexp | grep [.]dmp.gz | cut -f1 -d'.' | gawk '{print substr($0,1,length()-2)}' | uniq"
 end 
  
 output = ''
 Net::SSH.start( hostname, username, :password => password ) do|ssh|
 output = ssh.exec!(cmd)
 end
 a = []
 output.each_line { |line| a << line.strip unless line == "\n" }
 $evm.log(:info, "Source Exports: #{a}") if @debug
 export = Hash[ *a.compact.collect { |v| [ v, v] }.flatten ]
 export[''] = '<Choose>'

 dialog_field                    =      $evm.object
 dialog_field["sort_by"]         =      "value"
 dialog_field["sort_order"]      =      "ascending"
 dialog_field["data_type"]       =      "string"
 dialog_field['default_value']   =      output[0]
 dialog_field["required"]        =      "true"
 dialog_field["values"]          =      export
  
 rescue => err
 $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
 exit MIQ_ABORT
end
