#
# get_ora_cluster.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
  
  server_name = $evm.root['dialog_param_source_host'] 
  $evm.log(:info, "Servername: #{server_name}") if @debug
  database_name = $evm.root['dialog_param_source_database']
  $evm.log(:info, "DatabaseName: #{database_name}") if @debug
  oracle_schema = $evm.root['dialog_param_source_schema_old']
  $evm.log(:info, "SourceSchema: #{oracle_schema}") if @debug
  confirm = $evm.root['dialog_param_confirm']
  $evm.log(:info, "Confirm: #{confirm}") if @debug
  exit MIQ_OK if server_name.blank? || database_name.blank? || oracle_schema.blank? || confirm != 't'
  
  #Collect information from dialogs
  vcenter = String.new("Unified Database Cluster - Oracle Large")
  $evm.log(:info, "vcenter: #{vcenter}") if @debug
  exit MIQ_OK if vcenter.blank?

  v = $evm.vmdb(:ems).find_by_name("#{vcenter}").vms.collect {|vm| vm.name}.uniq
  $evm.log(:info, "VM_names: #{v}") if @debug
  vms = Hash[ *v.compact.collect { |v| [ v, v] }.flatten ]
  
  compression = (vms.include?(server_name))
  
  list_values = {
    'required' => true,
    'protected' => false,
    'read_only' => true,
    'value' => compression,
  }
  list_values.each do |key, value|
  $evm.object[key] = value
  end

  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
