#
# get_owners.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
  
  server_name = $evm.root['dialog_param_source_host'] 
  $evm.log(:info, "Servername: #{server_name}") if @debug
  database_name = $evm.root['dialog_param_source_database']
  $evm.log(:info, "DatabaseName: #{database_name}") if @debug
  exit MIQ_OK if server_name.blank? || database_name.blank?
  
  require 'oci8'
  hostname = $evm.object['hostname'] rescue nil
  $evm.log(:info, "Hostname: #{hostname}") if @debug
  username = $evm.object['username'] rescue nil
  $evm.log(:info, "Username: #{username}") if @debug
  password = $evm.object.decrypt('password') rescue nil
  
  q = []
  conn = OCI8.new("#{username}","#{password}","#{hostname}:1600/itsp")
  conn.exec("select distinct owner from ORAMAINT.OWNER where host_name='#{server_name}' and database_name='#{database_name}' and owner not in (select distinct owner from ORAMAINT.DEFAULT_OWNERS) order by 1") do |record|
    q << record.join(',')
  end

  $evm.log(:info, "Oracle_Schema: #{q}") if @debug
  oracle_schema = Hash[ *q.compact.collect { |v| [ v, v] }.flatten ]
  #oracle_schema[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      q[0]
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      oracle_schema
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
