#
# get_database.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
 
  server_name = $evm.root['dialog_host_name'] 
  $evm.log(:info, "Servername: #{server_name}") if @debug
  oracle_version = $evm.root['dialog_ora_version'] 
  $evm.log(:info, "OracleVersion: #{oracle_version}") if @debug
  product_name = $evm.root['dialog_ora_product']
  $evm.log(:info, "ProductName: #{product_name}") if @debug
  patch_version = $evm.root['dialog_patch_ver']
  $evm.log(:info, "PatchName: #{patch_version}") if @debug
  exit MIQ_OK if server_name.blank? || oracle_version.blank? || product_name.blank? || patch_version.blank? 
  
  require 'oci8'
  hostname = $evm.object['hostname'] rescue nil
  $evm.log(:info, "Hostname: #{hostname}") if @debug
  username = $evm.object['username'] rescue nil
  $evm.log(:info, "Username: #{username}") if @debug
  password = $evm.object.decrypt('password') rescue nil
   
  q = {}
  conn = OCI8.new("#{username}","#{password}","#{hostname}:1600/itsp")
  conn.exec("select distinct patch_type from oramaint.patching_parameters_vw where host_name='#{server_name}' and oracle_version='#{oracle_version}' and ora_product_short='#{product_name}' and patch_name='#{patch_version}' order by 1") do |record|
    q = record.join(',')
  end
  conn.logoff
  $evm.log(:info, "Patch_Type: #{q}") if @debug
  
  list_values = {
    'required' => true,
    'visible'  => false,
    'protected' => false,
    'read_only' => false,
    'value' => q,
  }
  list_values.each do |key, value|
  $evm.object[key] = value
  end
end
