#
# get_imperva_servers.rb
#
# Description: 
#

begin
  @debug = true
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  $evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
 
  server_type = $evm.root['dialog_server_type'] 
  $evm.log(:info, "OS: #{server_type}") if @debug
  exit MIQ_OK if server_type.blank?
   
  require 'json'
  require 'winrm'
    
  PS_SCRIPT = <<-PS_SCRIPT
  & D:\\CloudAutomation\\Scripts\\CloudformsImperva\\GetImpervaServers.ps1 -OS #{server_type}
PS_SCRIPT
   
  hostname = $evm.object['hostname']
  username = $evm.object['username']
  password = $evm.object.decrypt('password')
  endpoint = "http://#{hostname}:5985/wsman"
  
  params = { 
  endpoint: endpoint,
  user: username,
  password: password
  }
  
  data = []
  error = []

  winrm = WinRM::Connection.new(params)
  winrm.shell(:powershell) do |shell|
    shell.run(PS_SCRIPT) do |stdout, stderr|
      data << stdout
      error << stderr
    end
  end 
  
  $evm.log(:info, "Imperva Servers: #{data}") if @debug
  servers = Hash[ *data.collect { |v| [ v, v ] }.flatten ]
  servers[''] = '<Choose>'
  
  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field['visible']         =      "true"
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      servers
end
