#
# get_vm.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
  require 'pg'
  
  hostname = $evm.object['hostname'] rescue nil
  $evm.log(:info, "Hostname: #{hostname}") if @debug
  username = $evm.object['username'] rescue nil
  $evm.log(:info, "Username: #{username}") if @debug
  password = $evm.object.decrypt('password') rescue nil

  conn = PG.connect( :host => "#{hostname}", :dbname => 'vmdb_production', :port => 5432, :user => "#{username}", :password => "#{password}")
  vms = conn.exec('select v.name from vms v join operating_systems o on v.id=o.vm_or_template_id where o.product_name like \'%Windows%\' and v.ems_id in (10000000000003,10000000000004, 10000000000006) and v.template=\'f\';').values
  conn.close
  $evm.log(:info, "VM(s): #{vms}") if @debug
  servers = Hash[ *vms.compact.collect { |v| [ v, v] }.flatten ]
  servers[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      servers
  
  rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
