#
# Find VMs by patch admin tag
# 
#
#

begin
  @debug = true
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  $evm.object.attributes.sort.each { |k, v| $evm.log("info", "object: #{k}: #{v}") } if @debug
  request = $evm.root['vm']
  
  # Collect info from other dialogs.
  cur_own = $evm.root['dialog_option_1_curr_admin'] rescue nil
  $evm.log(:info, "Current Admin: #{cur_own}") if @debug
  cur_tag = '/patch_admin/' + cur_own
  $evm.log(:info, "Current Admin Tag: #{cur_tag}")
  exit MIQ_OK if cur_own.blank?

  v = $evm.vmdb(:vm_or_template).find_tagged_with(:all => cur_tag, :ns => "/managed")
  $evm.log(:info, "owned VMs: #{v.name}") if @debug
  vms = Hash[ *v.compact.collect { |v| [ v, v] }.flatten ]
  vms[''] = '<Choose>'

  dialog_field                    =      $evm.object
  dialog_field["sort_by"]         =      "value"
  dialog_field["sort_order"]      =      "ascending"
  dialog_field["data_type"]       =      "string"
  dialog_field['default_value']   =      ''
  dialog_field["required"]        =      "true"
  dialog_field["values"]          =      vms

rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
