#
# clone_vm.rb
#
# Description: <Method description here>
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  vm_name = $evm.root['vm']
  $evm.log(:info, "VMName: #{vm_name}") if @debug
  provider = $evm.root['vm'].vendor.downcase
  $evm.log(:info, "Provider: #{provider}") if @debug  
  clone_name = $evm.root['dialog_clone']
  $evm.log(:info, "CloneName: #{clone_name}") if @debug
  
  email = $evm.root['user'].email 
  email ||= $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank?
  $evm.log(:info, "result: #{data.inspect}")
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug
 
  if provider == 'vmware'  
    #Call PScall method to run ARPcloud-CreateClone.ps1 script
    #$evm.log(:info, "Instantiating PowerShell call") if @debug
    #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\ARPNET\\ArpCloud\\ARPcloud-CreateClone.ps1&value1=-NewVMName '#{clone_name}' -SourceVMName '#{vm_name}' -NTID '#{username}'")
    $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
    $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\ARPNET\\ArpCloud\\ARPcloud-CreateClone.ps1 -NewVMName '#{clone_name}' -SourceVMName '#{vm_name}' -NTID '#{username}'"
  else
    $evm.log(:info, "Operation Invalid") if @debug
    $evm.create_notification(:message => "Invalid Operation")
    exit MIQ_ABORT
 end
end
