#
# create_template.rb
#
# Description: <Method description here>
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  vm_name = $evm.root['vm'].to_s
  $evm.log(:info, "VMName: #{vm_name}") if @debug
  vm = $evm.vmdb(:vm).find_by_name(vm_name)
  raise "vm #{vm_name} not found" if vm.blank? 
  ems_id = vm.ems_id
  cluster_id = vm.ems_cluster_id
  vcenter = $evm.vmdb(:ems).find_by_id(ems_id).name.to_s
  $evm.log(:info, "vCenter: #{vcenter}") if @debug
  datacenter = $evm.vmdb(:ems_cluster).find_by_id(cluster_id).v_parent_datacenter.to_s
  $evm.log(:info, "Datacenter: #{datacenter}") if @debug
  vm_uuid = vm.uid_ems
  $evm.log(:info, "UUID: #{vm_uuid}") if @debug  
  provider = $evm.root['vm'].vendor.downcase
  $evm.log(:info, "Provider: #{provider}") if @debug   
  snapshot_name = $evm.root['dialog_snapshot']
  $evm.log(:info, "Snapshot: #{snapshot_name}") if @debug
  service = $evm.root['dialog_service']
  $evm.log(:info, "Service: #{service}") if @debug
  userid = $evm.root['user'].userid
  $evm.log(:info, "UserID: #{userid}") if @debug 
  
  
  #Email
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/Email?userid=#{userid}") 
  raise 'Error instantiating PScall' if data.blank? 
  email = $evm.root['Email']
  $evm.log(:info, "Email: #{email}") if @debug

  #NTID
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{userid}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug

  if provider == 'vmware'
    $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
    $evm.root['param11'] =  "vm_name=#{vm_name}"
    $evm.root['param12'] =  "vcenter=#{vcenter}"
    $evm.root['param13'] =  "datacenter=#{datacenter}" 
    $evm.root['param14'] =  "snapshot_name=#{snapshot_name}" 
    $evm.root['param15'] =  "service=#{service}"
    $evm.root['param16'] =  "vm_uuid=#{vm_uuid}"
    $evm.root['param17'] =  "email=#{email}" 
    $evm.root['param18'] =  "ntid=#{username}"
  else
    $evm.log(:info, "Operation Invalid") if @debug
    $evm.create_notification(:message => "Invalid Operation")
    exit MIQ_ABORT
  end
end
