#
# swap_slot.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  app_name = $evm.root['dialog_app_name']
  $evm.log(:info, "Application Name: #{app_name}") if @debug
  src_slot = $evm.root['dialog_src_slot'].match(/^([a-zA-Z0-9-\/]*)/).captures.first
  $evm.log(:info, "Source Slot: #{src_slot}") if @debug
  dest_slot = $evm.root['dialog_dest_slot'].match(/^([a-zA-Z0-9-\/]*)/).captures.first
  $evm.log(:info, "Destination Slot: #{dest_slot}") if @debug
  #app_insights = $evm.root['dialog_app_insights']
  #$evm.log(:info, "AppInsights Name: #{app_insights}") if @debug
  release_version = $evm.root['dialog_rel_version']
  $evm.log(:info, "Release Version: #{release_version}") if @debug
  request_number = $evm.root['dialog_req_number']
  $evm.log(:info, "Request Number: #{request_number}") if @debug
  
 
  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug

  #Call PScall method to run SwapAzureWebAppSlots.ps1 script
  #$evm.log(:info, "Instantiating PowerShell call") if @debug
  #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=D:\\Azure\\Functions\\SwapAzureWebAppSlots.ps1 -WebAppName '#{app_name}' -SourceSlot '#{src_slot}' -$DesinationSlot '#{dest_slot}' -NTID '#{username}'")
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] = "powershell_cmd=D:\\Azure\\WebApp\\Swap-AzureWebAppSlots.ps1 -WebAppName '#{app_name}' -SourceSlot '#{src_slot}' -DesinationSlot '#{dest_slot}' -releaseVersion '#{release_version}' -requestNumber '#{request_number}'-NTID '#{username}'"  
end
