#
# sql_database_tagging.rb
#
# Description: 
#

begin
  @debug = true
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  app_name = $evm.root['dialog_app_name'].match(/^([a-zA-Z0-9\/]*)/).captures.first
  $evm.log(:info, "Application Name: #{app_name}") if @debug
  asset_manager = $evm.root['dialog_asset_manager']
  $evm.log(:info, "Asset Manager: #{asset_manager}") if @debug

  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug

  #$evm.log(:info, "Instantiating PowerShell call") if @debug
  #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=D:\\Azure\\SQLDatabase\\Tag-TVASQLDatabase.ps1 -AppName '#{app_name}' -CI '#{asset_manager}' -Creator '#{creator}' -NTID '#{username}'")
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] = "powershell_cmd=D:\\Azure\\SQLDatabase\\Tag-TVASQLDatabase.ps1 -AppName '#{app_name}' -CI '#{asset_manager}' -Creator '#{username}' -NTID '#{username}'"  
end
