#
# web_app.rb
#
# Description: 
#

begin
  @debug = true
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  app_name = $evm.root['dialog_app_name']
  $evm.log(:info, "Application Name: #{app_name}") if @debug
  rg_name = $evm.root['dialog_rg_new']
  rg_name = $evm.root['dialog_rg_existing'].match(/^([a-zA-Z0-9-]*)/).captures.first if rg_name.blank?
  $evm.log(:info, "Resource Group: #{rg_name}") if @debug
  app_plan = $evm.root['dialog_app_service_plan']
  $evm.log(:info, "App Service Plan: #{app_plan}") if @debug
  ci = $evm.root['dialog_asset_manager']
  $evm.log(:info, "C.I: #{ci}") if @debug
 
  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug

  #$evm.log(:info, "Instantiating PowerShell call") if @debug
  #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=D:\\Azure\\WebApp\\WebAppDeploy.ps1 -AppName '#{app_name}' -ResourceGroup '#{rg_name}' -AppServicePlan '#{app_plan}' -CI '#{ci}' -NTID '#{username}'")
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] = "powershell_cmd=D:\\Azure\\WebApp\\WebAppDeploy.ps1 -AppName '#{app_name}' -ResourceGroup '#{rg_name}' -AppServicePlan '#{app_plan}' -CI '#{ci}' -NTID '#{username}'"  
end
