#
# vm_cleanup.rb
#
# Description: Cleanup archived and orphaned VMs and instances
#

begin
  @debug = true
  
  # Collect all the VMs
  vms = $evm.vmdb('vm').all.collect{|i| i.name}
  
  vms.each do | vm_name |
  vm = $evm.vmdb(:vm).find_by_name(vm_name)
  # Remove only if they are archived or orphaned 
  if vm.archived == true || vm.orphaned == true
    # Removes from VMDB
    $evm.log('info', "Removing VM <#{vm.name}> from VMDB")
    vm.remove_from_vmdb
    end
  end
  
rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
