#
# db_permissions_backup.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  destination_server = $evm.root['dialog_DestinationServer']
  $evm.log(:info, "DestinationServer: #{destination_server}") if @debug
  destination_instance = $evm.root['dialog_DestinationInstance']
  $evm.log(:info, "DestinationInstance: #{destination_instance}") if @debug
  destination_database = $evm.root['dialog_DestinationDatabase']
  $evm.log(:info, "DestinationDatabase: #{destination_database}") if @debug
  ticket = $evm.root['dialog_Ticket']
  $evm.log(:info, "Ticket: #{ticket}") if @debug
  retention = $evm.root['dialog_Retention']
  $evm.log(:info, "Retention: #{retention}") if @debug
 
  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug

  #Call PScall method to run Find-VM.ps1 script
  #$evm.log(:info, "Instantiating PowerShell call") if @debug
  #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\DBAautomation\\DBRefresh\\DBRefresh-PermissionsBackup.ps1&value1=-dest_srv '#{destination_server}' -dest_instance '#{destination_instance}' -dest_db '#{destination_database}' -ticket '#{ticket}' -retention '#{retention}' -NTID '#{username}'")
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\DBAautomation\\DBRefresh\\DBRefresh-PermissionsBackup.ps1 -DestinationServer '#{destination_server}' -DestinationInstance '#{destination_instance}' -DestinationDatabase '#{destination_database}' -ticket '#{ticket}' -retention '#{retention}' -NTID '#{username}'"
end
