#
# db_refresh.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  source_server = $evm.root['dialog_SourceServer']
  $evm.log(:info, "SourceServer: #{source_server}") if @debug
  source_instance = $evm.root['dialog_SourceInstance']
  $evm.log(:info, "SourceInstance: #{source_instance}") if @debug
  source_database = $evm.root['dialog_SourceDatabase']
  $evm.log(:info, "SourceDatabase: #{source_database}") if @debug
  destination_server = $evm.root['dialog_DestinationServer']
  $evm.log(:info, "DestinationServer: #{destination_server}") if @debug
  destination_instance = $evm.root['dialog_DestinationInstance']
  $evm.log(:info, "DestinationInstance: #{destination_instance}") if @debug
  destination_database = $evm.root['dialog_DestinationDatabase']
  $evm.log(:info, "DestinationDatabase: #{destination_database}") if @debug
  ticket = $evm.root['dialog_Ticket']
  $evm.log(:info, "Ticket: #{ticket}") if @debug
  retention = $evm.root['dialog_Retention']
  $evm.log(:info, "Retention: #{retention}") if @debug
  query = $evm.root['dialog_Query']
  $evm.log(:info, "Query: #{query}") if @debug
  query_server = $evm.root['dialog_QueryServer']
  $evm.log(:info, "QueryServer: #{query_server}") if @debug
  query_instance = $evm.root['dialog_QueryInstance']
  $evm.log(:info, "QueryInstance: #{query_instance}") if @debug
  request_id = $evm.root['service_template_provision_task'].miq_request_id
  $evm.log(:info, "Request ID: #{request_id}") if @debug
  schedule = $evm.root['dialog_schedule']
  $evm.log(:info, "Schedule: #{schedule}") if @debug
  time = $evm.root['dialog_time']
  $evm.log(:info, "Scheduled Time: #{time}") if @debug
 
  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug
  
  case schedule
    when 'Yes'
      $evm.log(:info, "Instantiating Ansible Tower API call") if @debug
      $evm.instantiate("/Integration/CommonMethods/Schedule/TowerCall?request_id=#{request_id}&scheduled_time=#{time}&cmd=C:\\vCO\\Scripts\\DBAautomation\\DBRefresh\\DBRefresh.ps1 -SourceServer '#{source_server}' -SourceInstance '#{source_instance}' -SourceDatabase '#{source_database}' -DestinationServer '#{destination_server}' -DestinationInstance '#{destination_instance}' -DestinationDatabase '#{destination_database}' -Ticket '#{ticket}' -Retention '#{retention}' -Query '#{query}' -QueryServer '#{query_server}' -QueryInstance '#{query_instance}' -NTID '#{username}'")  
      $evm.root['ae_next_state'] = 'service_cleanup'
    when 'No'
      #Call PScall method to run DBRefresh.ps1 script
      #$evm.log(:info, "Instantiating PowerShell call") if @debug
      #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\DBAautomation\\DBRefresh\\DBRefresh.ps1&value1=-src_srv '#{source_server}' -src_instance '#{source_instance}' -src_db '#{source_database}' -dest_srv '#{destination_server}' -dest_instance '#{destination_instance}' -dest_db '#{destination_database}' -ticket '#{ticket}' -retention '#{retention}' -query '#{query}' -query_srv '#{query_server}' -query_instance '#{query_instance}' -NTID '#{username}'")
      $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
      $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\DBAautomation\\DBRefresh\\DBRefresh.ps1 -SourceServer '#{source_server}' -SourceInstance '#{source_instance}' -SourceDatabase '#{source_database}' -DestinationServer '#{destination_server}' -DestinationInstance '#{destination_instance}' -DestinationDatabase '#{destination_database}' -Ticket '#{ticket}' -Retention '#{retention}' -Query '#{query}' -QueryServer '#{query_server}' -QueryInstance '#{query_instance}' -NTID '#{username}'"
  end
 end
