#
# app_pools.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  server_name = $evm.root['dialog_ServerName']
  $evm.log(:info, "ServerName: #{server_name}") if @debug
  app_pool = $evm.root['dialog_AppPool']
  $evm.log(:info, "AppPool: #{app_pool}") if @debug
  ticket = $evm.root['dialog_Ticket']
  $evm.log(:info, "Ticket: #{ticket}") if @debug
  user_action = $evm.root['dialog_userAction']
  $evm.log(:info, "userAction: #{user_action}") if @debug
  username = $evm.root['dialog_Username']
  $evm.log(:info, "Username: #{username}") if @debug
  password = $evm.root.decrypt('dialog_Password')
  $evm.log(:info, "Password: #{password}") if @debug
    

  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  ntid = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "NTID: #{ntid}") if @debug
  
  #Call PScall method to run Set-TVAAppPoolCred.ps1 script
  #$evm.log(:info, "Instantiating PowerShell call") if @debug
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  if user_action == 'Change AppPool Credentials'
    #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\Platform\\AppPools\\Set-TVAAppPoolCred.ps1&value1=-Server '#{server_name}' -AppPool '#{app_pool}' -Ticket '#{ticket}' -Username '#{username}' -password '#{password}' -NTID '#{ntid}'")
    $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Platform\\AppPools\\Set-TVAAppPoolCred.ps1 -Server '#{server_name}' -AppPool '#{app_pool}' -Ticket '#{ticket}' -Username '#{username}' -password '#{password}' -NTID '#{ntid}'"
  else
    #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\Platform\\AppPools\\Set-TVAAppPool.ps1&value1=-Server '#{server_name}' -AppPool '#{app_pool}' -Ticket '#{ticket}' -userAction '#{user_action}' -NTID '#{ntid}'")
    $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Platform\\AppPools\\Set-TVAAppPool.ps1 -Server '#{server_name}' -AppPool '#{app_pool}' -Ticket '#{ticket}' -userAction '#{user_action}' -NTID '#{ntid}'"
  end
end
