#
# imperva_service.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  server_type = $evm.root['dialog_server_type']
  $evm.log(:info, "OS: #{server_type}") if @debug
  server_name = $evm.root['dialog_server_name'].match(/^([a-zA-Z0-9.]*)/).captures.first
  $evm.log(:info, "ServerName: #{server_name}") if @debug
  state = $evm.root['dialog_state']
  $evm.log(:info, "Action: #{state}") if @debug
  userid = $evm.root['user'].userid
  $evm.log(:info, "UserID: #{userid}") if @debug  
  
  #Email
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/Email?userid=#{userid}") 
  raise 'Error instantiating PScall' if data.blank? 
  email = $evm.root['Email']
  $evm.log(:info, "Email: #{email}") if @debug

  #NTID
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{userid}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug
    
  #Collect parameters to launch Ansible Tower
  server_name = server_name.downcase
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] =  "server_type=#{server_type}"
  $evm.root['param12'] =  "server_name=#{server_name}"
  $evm.root['param13'] =  "service_state=#{state}" 
  $evm.root['param14'] =  "email=#{email}" 
  $evm.root['param15'] =  "username=#{username}"
end
