#
# create_deployment_parameters.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  deployment_group = $evm.root['dialog_group_name'].upcase
  $evm.log(:info, "Deployment Group Name: #{deployment_group}") if @debug
  group_exist = $evm.root['dialog_group_exist']
  $evm.log(:info, "Deployment Group Exist In Target Repository: #{group_exist}") if @debug
  replace_existing = $evm.root['dialog_replace_existing']
  $evm.log(:info, "Replace Existing Deployment Parameters: #{replace_existing}") if @debug
  expected_folders = $evm.root['dialog_expected_folders']
  $evm.log(:info, "Expected Folders: #{expected_folders}") if @debug
  date = Time.now.strftime("%Y%m%d%H%M%S")
  
  if $evm.root['dialog_env'] == 'Acceptance'
    server_name = 'pwcdn1'
    $evm.log(:info, "Server Name: #{server_name}") if @debug
  else
    server_name = 'pwcan1'
    $evm.log(:info, "Server Name: #{server_name}") if @debug
  end

  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug
  
flag = <<-EOF
#{deployment_group} NO NO YES #{expected_folders} #{group_exist} NA NA NA NA NA #{username} #{date}
EOF
  $evm.log(:info, "ObjectFile: #{flag}") if @debug
  
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] =  "server_name=#{server_name}.main.tva.gov"
  $evm.root['param12'] =  "deployment_group=#{deployment_group}" 
  $evm.root['param13'] =  "replace_existing=#{replace_existing}" 
  $evm.root['param14'] =  "file_content=#{flag}" 
    
  #Define State variables
  $evm.set_state_var(:server_name, "#{server_name}")
  $evm.set_state_var(:deployment_group, "#{deployment_group}")
  $evm.set_state_var(:file_content, "#{flag}")
end
