#
# email.rb
#
# Description: <Method description here>
#
begin
  
  server_name = $evm.get_state_var(:server_name)
  deployment_group = $evm.get_state_var(:deployment_group)
  file_content = $evm.get_state_var(:file_content)
  
  userid = $evm.root['user'].userid
  $evm.log(:info, "UserID: #{userid}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/Email?userid=#{userid}") 
  raise 'Error instantiating PScall' if data.blank? 
  email = $evm.root['Email']
  $evm.log(:info, "Email: #{email}") if @debug
  
  if email
    to = email,$evm.object['to_email_address'] 
  else
    to = $evm.object['to_email_address']
  end

  # Get from_email_address from model unless specified below
  from = nil
  from ||= $evm.object['from_email_address']

  # Get signature from model unless specified below
  signature = nil
  signature ||= $evm.object['signature']
  
  # email subject
  subject = "Informatica ParamFile Creation"

  # Build email body
  body = "<font size='3' face='Calibri'>"
  body += "Cloudforms has successfully updated file on <b>#{server_name}</b>."
  body += "<br><br><b>File Contents:</b>"
  body += "<br>#{file_content}"
 
  #
  # Send email
  #
  $evm.log("info", "Sending email to <#{to}> from <#{from}> subject: <#{subject}>")
  $evm.execute('send_email', to, from, subject, body)
end
