#
# object_promotion.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  deployment_group = $evm.root['dialog_group_name'].upcase
  $evm.log(:info, "Deployment Group Name: #{deployment_group}") if @debug
  folder_backup = $evm.root['dialog_folder_backup']
  $evm.log(:info, "Folder Backup: #{folder_backup}") if @debug

  #Collect server name based on environment
  if $evm.root['dialog_env'] == 'Acceptance'
    server_name = 'pwcdn1'
    $evm.log(:info, "Server Name: #{server_name}") if @debug
  else
    server_name = 'pwcan1'
    $evm.log(:info, "Server Name: #{server_name}") if @debug
  end
  
  userid = $evm.root['user'].userid
  $evm.log(:info, "UserID: #{userid}") if @debug   
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/Email?userid=#{userid}") 
  raise 'Error instantiating PScall' if data.blank? 
  email = $evm.root['Email']
  $evm.log(:info, "Email: #{email}") if @debug
   
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] =  "server_name=#{server_name}.main.tva.gov"
  $evm.root['param12'] =  "deployment_group=#{deployment_group}" 
  $evm.root['param13'] =  "folder_backup=#{folder_backup}" 
  $evm.root['param14'] =  "email=#{email}"
end
