#
# ticket_creation.rb
#
# Description: 
#

begin
  @debug = true
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug  

  #Collect information from dialogs
  server_name = $evm.root['dialog_option_1_vm_name'] + '.main.tva.gov'
  $evm.log(:info, "server_name: #{server_name}")
  cluster_name = $evm.root['dialog_option_1_cluster_name']
  $evm.log(:info, "cluster_name: #{cluster_name}")
  cluster = $evm.vmdb(:ems_cluster).find_by_name(cluster_name)
  raise "cluster #{cluster_name} not found!" if cluster.blank?
  $evm.log(:info, "Cluster: #{cluster.name}")
  ems_id = cluster.ems_id
  $evm.log(:info, "ems_id: #{ems_id}")
  vcenter_name = $evm.vmdb(:ems).find_by_id(ems_id).name
  $evm.log(:info, "vcenter_name: #{vcenter_name}")
  datacenter_name = ''
  $evm.vmdb(:ems).find_by_name("#{vcenter_name}").ems_clusters.each {|cluster| datacenter_name = cluster.v_parent_datacenter if cluster.name == "#{cluster_name}"}.to_s
  datacenter_name = datacenter_name.gsub('%2f','/')
  $evm.log(:info, "datacenter_name: #{datacenter_name}")
  
  city = $evm.root['dialog_tag_1_city'].first.name 
  $evm.log(:info, "city: #{city}")
  if city == 'cha'
    city_name = 'Chattanooga'
  elsif city == 'knx'
    city_name = 'Knoxville'
  elsif city == 'msh'
    city_name = 'Muscle Shoals'
  else
    city_name = 'Nashville'
  end
  $evm.log(:info, "city: #{city_name}")
  
  environment = $evm.root['dialog_tag_1_environment'].first.name
  if environment == 'prod'
    environment_name = 'Production'
  elsif environment == 'acpt'
    environment_name = 'Acceptance'
  else
    environment_name = 'Development'
  end  
  $evm.log(:info, "environment: #{environment_name}")
  
  change_id = $evm.root['dialog_option_1_changeid'] 
  $evm.log(:info, "change_id : #{change_id}")
  description = $evm.root['dialog_description'] 
  $evm.log(:info, "description: #{description}")
  sox = $evm.root['dialog_sox'] 
  $evm.log(:info, "sox : #{sox}") 
  
  role = $evm.root['dialog_tag_1_role'].first.name 
  $evm.log(:info, "role : #{role}") 
  if role == 'db'
    database = 'Oracle'
  else
    database = 'N/A'
  end
  $evm.log(:info, "Database : #{database}") 
  
  email ||= $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank?
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug
  
  #Call PScall method to run Find-VM.ps1 script
  #$evm.log(:info, "Instantiating PowerShell call") if @debug
  #evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\VMware\\FindVM\\Find-VM.ps1&value1=-machine '#{name}' -NTID '#{username}'")
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Compute\\Linux\\LinuxServerDeployTickets\\LinuxServerDeployTickets.ps1 -Name '#{server_name}' -vCenter '#{vcenter_name}' -Datacenter '#{datacenter_name}' -City '#{city_name}' -ChangeID '#{change_id}' -Description '#{description}' -Timezone 'EST' -Environment '#{environment_name}' -Database '#{database}' -SoxNerc '#{sox}' -BackupType 'Standard' -NTID '#{username}' -Test 'No'"
  
end
