#
# mdr_access.rb
#
# Description: Minimum Developer Rights Access
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  # Collect information from dialogs
  access = $evm.root['dialog_access']
  $evm.log(:info, "Access Required: #{access}") if @debug
  group_name = $evm.root['dialog_group_name']
  $evm.log(:info, "MDR Group Name: #{group_name}") if @debug
  objects = $evm.root['dialog_objects']
  $evm.log(:info, "Users: #{objects}") if @debug
  
  # Formats the users & machines variables as required
  objects = "'#{objects.join("','")}'" unless objects.blank?
  $evm.log(:info, "Users/Machines: #{objects}") if @debug

  # Gets the requestor's SamAccountName
  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug

  # Collects parameters to launch Ansible Tower
  if access == 'Users'
    $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Cloudforms\\MDR\\New-TVAMDRAccess.ps1 -MDRGroup '#{group_name}' -Users #{objects} -Test 'No' -NTID '#{username}'"
  else
    $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Cloudforms\\MDR\\New-TVAMDRAccess.ps1 -MDRGroup '#{group_name}' -Machines #{objects} -Test 'No' -NTID '#{username}'"
  end
end
