#
# mdr_setup.rb
#
# Description: Minimum Developer Rights Setup
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  # Collect information from dialogs
  ci_shortname = $evm.root['dialog_ci'].upcase
  $evm.log(:info, "CI Shortname: #{ci_shortname}") if @debug
  environment = $evm.root['dialog_environment']
  $evm.log(:info, "Environment: #{environment}") if @debug
  group_owner = $evm.root['dialog_group_owner']
  $evm.log(:info, "MDR Group Owner: #{group_owner}") if @debug
  users = $evm.root['dialog_users']
  $evm.log(:info, "Users: #{users}") if @debug
  machines = $evm.root['dialog_machines']
  $evm.log(:info, "Machines: #{machines}") if @debug
  
  # Formats the users & machines variables as required
  users = "'#{users.join("','")}'"
  $evm.log(:info, "Users: #{users}") if @debug
  machines = "'#{machines.join("','")}'"
  $evm.log(:info, "Machines: #{machines}") if @debug
  
  # Gets the requestor's SamAccountName
  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug

  # Collects parameters to launch Ansible Tower
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Cloudforms\\MDR\\New-TVAMDRSetup.ps1 -CIShortName '#{ci_shortname}' -Environment '#{environment}' -MDRGroupOwner '#{group_owner}' -Users #{users} -Machines #{machines} -Test 'No' -NTID '#{username}'"
end
