#
# oracle_patching.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  #$evm.object.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  server_name = $evm.root['dialog_host_name']
  $evm.log(:info, "ServerName: #{server_name}") if @debug
  oracle_version = $evm.root['dialog_ora_version']
  $evm.log(:info, "OracleVersion: #{oracle_version}") if @debug
  product_name = $evm.root['dialog_ora_product']
  $evm.log(:info, "ProductName: #{product_name}") if @debug
  patch_name = $evm.root['dialog_patch_ver']
  $evm.log(:info, "PatchName: #{patch_name}") if @debug
  full_product = $evm.root['dialog_product']
  $evm.log(:info, "FullProduct: #{full_product}") if @debug
  database_name = $evm.root['dialog_database_name']
  $evm.log(:info, "DatabaseName: #{database_name}") if @debug
  product_version = product_name.gsub(/product/, '')
  $evm.log(:info, "ProductVersion: #{product_version}") if @debug
  patch_directory = "#{oracle_version}_install-linux"
  $evm.log(:info, "PatchDirectory: #{patch_directory}") if @debug
  patch_binaries = $evm.root['dialog_patch_binary']
  $evm.log(:info, "PatchBinaries: #{patch_binaries}") if @debug
  patch_type = $evm.root['dialog_patch_type']
  $evm.log(:info, "PatchType: #{patch_type}") if @debug
  overwrite = $evm.root['dialog_reset']
  $evm.log(:info, "Reset : #{overwrite}") if @debug
  request_id = $evm.root['service_template_provision_task'].miq_request_id
  $evm.log(:info, "Request ID: #{request_id}") if @debug
  schedule = $evm.root['dialog_schedule']
  $evm.log(:info, "Schedule: #{schedule}") if @debug
  time = $evm.root['dialog_time']
  $evm.log(:info, "Scheduled Time: #{time}") if @debug
  
  case schedule
    when 'Yes'
      $evm.log(:info, "Instantiating Ansible Tower API call") if @debug
      $evm.instantiate("/Integration/CommonMethods/Schedule/OraclePatch?request_id=#{request_id}&scheduled_time=#{time}&server_name=#{server_name}&product_name=#{product_name}&product_version=#{product_version}&patch_name=#{patch_name}&patch_directory=#{patch_directory}&patch_binaries=#{patch_binaries}&database_name=#{database_name}&patch_type=#{patch_type}&overwrite=#{overwrite}")  
      $evm.root['ae_next_state'] = 'EmailOwner'
    else
      $evm.root['param11'] = "server_name=#{server_name}"
      $evm.root['param12'] = "product_name=#{product_name}"
      $evm.root['param13'] = "product_version=#{product_version}"
      $evm.root['param14'] = "patch_name=#{patch_name}"
      $evm.root['param15'] = "patch_directory=#{patch_directory}"
      $evm.root['param16'] = "patch_binaries=#{patch_binaries}"
      $evm.root['param17'] = "database_name=#{database_name}"
      $evm.root['param18'] = "patch_type=#{patch_type}"
      $evm.root['param19'] = "overwrite=#{overwrite}"
  end
  
  #Define State variables
  $evm.set_state_var(:server_name, "#{server_name}")
  $evm.set_state_var(:product_name, "#{product_name}")
  $evm.set_state_var(:product_version, "#{product_version}")
  $evm.set_state_var(:patch_name, "#{patch_name}")
  $evm.set_state_var(:patch_directory, "#{patch_directory}")
  $evm.set_state_var(:patch_binaries, "#{patch_binaries}")
  $evm.set_state_var(:database_name, "#{database_name}")
  $evm.set_state_var(:patch_type, "#{patch_type}")
end
