#
# oracle_patching_email.rb
#
# Description: <Method description here>
#
begin
  
  schedule = $evm.root['dialog_schedule']
  $evm.log(:info, "Schedule: #{schedule}") if @debug
  server_name = $evm.get_state_var(:server_name)
  product_name = $evm.get_state_var(:product_name)
  product_version = $evm.get_state_var(:product_version)
  patch_name = $evm.get_state_var(:patch_name)
  patch_directory = $evm.get_state_var(:patch_directory)
  patch_binaries = $evm.get_state_var(:patch_binaries)
  database_name = $evm.get_state_var(:database_name)
  patch_type = $evm.get_state_var(:patch_type)
  userid = $evm.root['user'].userid
  $evm.log(:info, "UserID: #{userid}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/Email?userid=#{userid}") 
  raise 'Error instantiating PScall' if data.blank? 
  email = $evm.root['Email']
  $evm.log(:info, "Email: #{email}") if @debug
  
  if email
    to = email,$evm.object['to_email_address'],'ncbrouhard@tva.gov'
  else
    to = $evm.object['to_email_address']
  end

  # Get from_email_address from model unless specified below
  from = nil
  from ||= $evm.object['from_email_address']

  # Get signature from model unless specified below
  signature = nil
  signature ||= $evm.object['signature']
  
  if schedule == 'Yes'
    # email subject
    subject = "Oracle Automated Patching Controller File Update Scheduled"

    # Build email body
    body = "<font size='3' face='Calibri'>"
    body += "Cloudforms has successfully scheduled the update of .automated_patching_controller file on <b>#{server_name}</b>."
    body += "<br><br><b>Path to Controller File:</b>"
    body += "<br>oracle@<b>#{server_name}</b>: /u01/app/oracle/local/maint/.automated_patching_controller"
    body += "<br><br><b>Controller File Variables:</b>"
    body += "<br>PRODUCT_NAME: <b>#{product_name}</b>"
    body += "<br>PRODUCT_VERSION: <b>#{product_version}</b>"
    body += "<br>PATCH_NAME: <b>#{patch_name}</b>"
    body += "<br>PATCH_DIRECTORY: <b>#{patch_directory}</b>"
    body += "<br>PATCH_BINARIES: <b>#{patch_binaries}</b>"
    body += "<br>DATABASE_NAME: <b>#{database_name}</b>"
    body += "<br>PATCH_TYPE: <b>#{patch_type}</b>"
  else
    # email subject
    subject = "Oracle Automated Patching Controller File Updated"

    # Build email body
    body = "<font size='3' face='Calibri'>"
    body += "Cloudforms has successfully updated the .automated_patching_controller file on <b>#{server_name}</b>."
    body += "<br><br><b>Path to Controller File:</b>"
    body += "<br>oracle@<b>#{server_name}</b>: /u01/app/oracle/local/maint/.automated_patching_controller"
    body += "<br><br><b>Controller File Variables:</b>"
    body += "<br>PRODUCT_NAME: <b>#{product_name}</b>"
    body += "<br>PRODUCT_VERSION: <b>#{product_version}</b>"
    body += "<br>PATCH_NAME: <b>#{patch_name}</b>"
    body += "<br>PATCH_DIRECTORY: <b>#{patch_directory}</b>"
    body += "<br>PATCH_BINARIES: <b>#{patch_binaries}</b>"
    body += "<br>DATABASE_NAME: <b>#{database_name}</b>"
    body += "<br>PATCH_TYPE: <b>#{patch_type}</b>"
  end
  #
  # Send email
  #
  $evm.log("info", "Sending email to <#{to}> from <#{from}> subject: <#{subject}>")
  $evm.execute('send_email', to, from, subject, body)
end
