#
# gp_web_deploy.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  env = $evm.root['dialog_env']
  $evm.log(:info, "Env: #{env}") if @debug
  webserver = $evm.root['dialog_webServer']
  $evm.log(:info, "Webserver: #{webserver}") if @debug
  site_name = $evm.root['dialog_siteName']
  $evm.log(:info, "SiteName: #{site_name}") if @debug
  vanity_url = $evm.root['dialog_vanityURL']
  $evm.log(:info, "VanityURL: #{vanity_url}") if @debug
  new_group = $evm.root['dialog_newGroup']
  $evm.log(:info, "NewGroup: #{new_group}") if @debug
  owner = $evm.root['dialog_owner']
  $evm.log(:info, "Owner: #{owner}") if @debug
  add_approvers = $evm.root['dialog_addApprovers']
  $evm.log(:info, "addApprovers: #{add_approvers}") if @debug
  members = $evm.root['dialog_members']
  $evm.log(:info, "Members: #{members}") if @debug
  existing_group = $evm.root['dialog_existingGroup']
  $evm.log(:info, "existingGroup: #{existing_group}") if @debug
  ticket = $evm.root['dialog_ticket']
  $evm.log(:info, "Ticket: #{ticket}") if @debug
 

  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug
  
  case env
    when "Development"
		case webserver
			when "OSD Web Farm"
				cName = "wosdwebd.glb.tva.gov"
				webServerName = "CHADWOSDWEB1"
				share = "NO"
			when "2012 GP Web Farm"
				cName = "gpwinweb2012dev.glb.tva.gov"
				webServerName = "CHADWGPWEB01"
				share = "NO"
            when "2012 GP Stand Alone"
			    cName = "chadwgpweb02.main.tva.gov"
			    webServerName = "CHADWGPWEB02"
				share = "NO"
			when "2016 GP Chattanooga"
				cName = "chadwgpweb16.main.tva.gov"
				webServerName = "CHADWGPWEB16"
				share = "NO"
			when "2016 GP Knoxville"
				cName = "knxdwgpweb16.main.tva.gov"
				webServerName = "KNXDWGPWEB16"
				share = "NO"
		end
	when "Acceptance"
		case webserver
			when "OSD Web Farm"
				cName = "wosdweba.glb.tva.gov"
				webServerName = "CHAAWOSDWEB1"
				share = "NO"
			when "2012 GP Web Farm"
				cName = "gpwinweb2012acp.glb.tva.gov"
				webServerName = "CHAAWGPWEB01"
				share = "NO"
            when "2012 GP Stand Alone"
                cName = "knxawgpweb02.main.tva.gov"
                webServerName = "KNXAWGPWEB02"
				share = "NO"
			when "2016 GP Chattanooga"
				cName = "chaawgpweb16.main.tva.gov"
				webServerName = "CHAAWGPWEB16"
				share = "NO"
			when "2016 GP Knoxville"
				cName = "knxawgpweb16.main.tva.gov"
				webServerName = "KNXAWGPWEB16"
				share = "NO"
		end
	when "Production"
		case webserver
			when "OSD Web Farm"
				cName = "wosdwebp.glb.tva.gov"
				webServerName = "CHAPWOSDWEB1"
				share = "NO"
			when "2012 GP Web Farm"
				cName = "gpwinweb2012prd.glb.tva.gov"
				webServerName = "CHAPWGPWEB01"
				share = "NO"
            when "2012 GP Stand Alone"
				cName = "chapwgpweb02.main.tva.gov"
				webServerName = "CHAPWGPWEB02"
				share = "NO"
			when "2016 GP Chattanooga"
				cName = "chapwgpweb16.main.tva.gov"
				webServerName = "CHAPWGPWEB16"
				share = "NO"
			when "2016 GP Knoxville"
				cName = "knxpwgpweb16.main.tva.gov"
				webServerName = "KNXPWGPWEB16"
				share = "NO"	
	      end	
  end
  
  #Call PScall method to run GPDeployWeb.ps1 script
  #$evm.log(:info, "Instantiating PowerShell call") if @debug
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  if new_group == "Yes"
    #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\GP Web Deploy\\GPDeployWeb.ps1&value1=-webServer '#{webServerName}' -siteName '#{site_name}' -HostHeader '#{host_header}' -owner '#{owner}' -addApprovers '#{add_approvers}' -Env '#{env}' -ticket '#{ticket}' -cName '#{cName}' -shareCreate '#{share}' -members '#{members}' -newGroup \"1\" -existingGroup \"NA\" -ntid '#{username}'")
    $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Platform\\GPWebDeploy\\GPWebDeploy.ps1 -webServer '#{webServerName}' -siteName '#{site_name}' -VanityURL '#{vanity_url}' -owner '#{owner}' -addApprovers #{add_approvers} -ticket '#{ticket}' -CanonicalName '#{cName}' -shareCreate '#{share}' -members #{members} -existingGroup \"NA\" -ntid '#{username}'"
  else
    #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\GP Web Deploy\\GPDeployWeb.ps1&value1=-webServer '#{webServerName}' -siteName '#{site_name}' -HostHeader '#{host_header}' -owner \"null\" -addApprovers \"null\" -Env '#{env}' -ticket '#{ticket}' -cName '#{cName}' -shareCreate '#{share}' -members '#{members}' -newGroup \"0\" -existingGroup '#{existing_group}' -ntid '#{username}'")	
    #$evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\GPWebDeploy\\GPWebDeploy.ps1 -webServer '#{webServerName}' -siteName '#{site_name}' -HostHeader '#{host_header}' -owner \"$null\" -addApprovers \"$null\" -Env '#{env}' -ticket '#{ticket}' -cName '#{cName}' -shareCreate '#{share}' -members '#{members}' -newGroup \"0\" -existingGroup '#{existing_group}' -ntid '#{username}'"
    $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Platform\\GPWebDeploy\\GPWebDeploy.ps1 -webServer '#{webServerName}' -siteName '#{site_name}' -VanityURL '#{vanity_url}' -ticket '#{ticket}' -CanonicalName '#{cName}' -shareCreate '#{share}' -existingGroup '#{existing_group}' -ntid '#{username}'"
  end
end
