#
# apply_tags: Apply tags required for TVA Windows provisioning.
#
# Author: jcutter@redhat.com
#

begin

  ###################
  # Start method
  ###################

  @debug = true
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  # Get vm_name from dialog.
  provider = $evm.root['dialog_option_2_Provider']
  vm_name = $evm.root['dialog_option_1_name']
  vm_name ||= $evm.get_state_var(:dialog_option_1_name)
  vm_name ||= $evm.root['dialog_clone']
  raise 'vm_name not found!' if vm_name.blank?

  # Get vm object.
  vm = $evm.vmdb(:vm).find_by_name(vm_name)
  raise 'vm object not found!' if vm.blank?

#  # If this is ARPcloud tag it with everything in the tva_group tag category.
#  service = $evm.root['service_template_provision_task']
#  $evm.log(:info, "service.name: #{service.name}") if @debug
#  exit MIQ_OK unless service.name == 'ARPcloud'
#
#  # To tag with all group tags in tva_group.
#  # Get all of the tags in tva_group.
#  classification = $evm.vmdb(:classification).find_by_name('tva_group')
#  tags = []
#  $evm.vmdb(:classification).where(:parent_id => classification.id).each do |tag|
#    tags << tag.name
#  end
#  # Apply all tags from tva_group to VM.
#  tags.each do |tag
#    vm.tag_assign("tva_group/#{tag}")
#  end
  
  #If it is Maximo server tag with maximo.developers 
  server_prefix = vm.name[0..2]
  $evm.log(:info, "server_prefix: #{server_prefix}") if @debug
  if server_prefix == 'MAX'
    vm.tag_assign('tva_group/maximo_developers')
    vm.tag_assign('lifecycle/soft_retire')
  elsif provider == 'Azure'
    vm.tag_assign('tva_group/it_information_technology')
    vm.tag_assign('tva_group/it_information_technology_employees_only')
    vm.tag_assign('tva_group/innovation_center')
  else
    vm.tag_assign('tva_group/it_information_technology')
    vm.tag_assign('tva_group/it_information_technology_employees_only')
    vm.tag_assign('tva_group/innovation_center')
    vm.tag_assign('lifecycle/soft_retire')
  end
  # If you want to tag only some of the groups, comment the above and you can do so using:
  # vm.tag_assign('tva_group/aws_dbas')
 
  exit MIQ_OK

rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
