
#
# assign_ownership: Assign the ownership to the VM now that it has been discovered.
#
# Author: jcutter@redhat.com
#

begin

  ###################
  # Start method
  ###################

  @debug = true
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  # Get user object.
  user = $evm.root['user']
  raise 'Unable to find user!' if user.blank?

  # Get group object.
  group = $evm.root['miq_group']
  raise 'Unable to find group!' if group.blank?

  # Get vm_name from dialog.
  vm_name = $evm.root['dialog_option_1_name']
  vm_name ||= $evm.get_state_var(:dialog_option_1_name)
  vm_name ||= $evm.root['dialog_clone']
  vm_name ||= $evm.root['dialog_template']
  raise 'vm_name not found!' if vm_name.blank?

  # Get vm object.
  vm = $evm.vmdb(:vm_or_template).find_by_name(vm_name)
  raise 'vm object not found!' if vm.blank?

  # Assign ownership.
  vm.owner = user
  vm.group = group

  exit MIQ_OK

rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
