#
# assign_retirement_date: 
#
#

begin

  @debug = true
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  # Get vm_name from dialog.
  provider = $evm.root['dialog_option_2_Provider']
  vm_name = $evm.root['dialog_option_1_name']
  vm_name ||= $evm.get_state_var(:dialog_option_1_name)
  vm_name ||= $evm.root['dialog_clone']
  raise 'vm_name not found!' if vm_name.blank?
  
  $evm.log(:info, "Provider: #{provider}") if @debug
  exit MIQ_OK unless provider == 'OnPremises'

  # Get vm object.
  vm = $evm.vmdb(:vm).find_by_name(vm_name)
  raise 'vm object not found!' if vm.blank?

  vmname = vm.name
  
  if vm.retires_on.nil?
    vm.retires_on = Time.now + 60.days
    vm.retirement_warn = 14
  end

  $evm.log("info", "VM <#{vmname}> current retirement date is set to #{vm.retires_on}")
     
rescue => err
  $evm.log(:error, "[(#{err.class})#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
