#
# Description: Used for TVA Windows VM provisions.  This method is used to continue to retry the service provision until the VM is is found in the VMDB to facilitate being able to set owner/group and tag the VM.
#
# Author: jcutter@redhat.com
#

# Skipping states for TicketsOnly

if $evm.root['dialog_option_1_Test'] == "TicketsOnly"
  $evm.root['ae_next_state'] = 'post5'
  exit MIQ_OK
end

# Get target VM name from the dialog.

target_vm_name = $evm.root['dialog_option_1_name']
#target_vm_name ||= $evm.root['dialog_sanbox_name'].upcase
target_vm_name ||= $evm.get_state_var(:dialog_option_1_name)
target_vm_name ||= $evm.root['dialog_clone']
target_vm_name ||= $evm.root['dialog_template']

if target_vm_name.blank?
  raise 'name not found!'
else
  vm = $evm.vmdb(:vm_or_template).find_by_name(target_vm_name) rescue nil
end

# If vm not yet found.
if vm == nil
  # Schedule retry.
  $evm.root['ae_result']         = 'retry'
  $evm.root['ae_retry_interval'] = '1.minute'
  $evm.log(:info, "VM #{target_vm_name} not found, scheduling retry.")
else
  $evm.log(:info, "VM #{target_vm_name} found!")
end

exit MIQ_OK
