#
# Description: This method is executed when the provisioning request is auto-approved
#

# Auto-Approve request

@debug = true
#$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
#$evm.root['service_template_provision_request'].attributes.sort.each { |k, v| $evm.log("info", "service_template_provision_request: #{k}: #{v}") } if @debug

$evm.log("info", "Checking for auto_approval")
approval_type = $evm.object['approval_type'].downcase
@miq_request = $evm.root['miq_request']
dialog_options = @miq_request['options'][:dialog]

$evm.log('info', "catalog item name: #{$evm.root['service_template_provision_request'].source.name}")
no_auto_catalog_items = ['Shiny App Creation', 'Shiny App Migration'] 
if no_auto_catalog_items.include?($evm.root['service_template_provision_request'].source.name)
  if $evm.root['service_template_provision_request'].source.name == 'Shiny App Migration' 
    #Shiny Migration
    app_short_name = dialog_options['dialog_short_name']
    $evm.log("info", "AppShortName: #{app_short_name }")
    result = $evm.instantiate("/Integration/CommonMethods/PowerShell/PScall?script=C:\\vCO\\Scripts\\Cloudforms\\Shiny\\Get-TVAShinyAppOwner.ps1&value1=-AppShortName '#{app_short_name}'")
    raise 'Error instantiating PScall' if result.blank?
    $evm.log(:info, "result: #{result.inspect}")
    app_owner = $evm.root['ps_data'].match(/(^[a-zA-z0-9]{1,25}@tva.gov$)/).captures.first
    $evm.log(:info, "AppOwner: #{app_owner}") if @debug
    userid = $evm.root['user'].userid
    $evm.log(:info, "UserID: #{userid}") if @debug    
    data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/Email?userid=#{userid}") 
    raise 'Error instantiating PScall' if data.blank? 
    app_requestor = $evm.root['Email']
    $evm.log(:info, "AppRequestor: #{app_requestor}") if @debug
    if app_owner == app_requestor
       approval_type = 'auto'
    else
       approval_type = 'manual'
    end
  else
    approval_type = 'manual'
  end
end

if approval_type == 'auto'
  $evm.log("info", "AUTO-APPROVING")
  $evm.root["miq_request"].approve("admin", "Auto-Approved")
else
  $evm.log("info", "Not Auto-Approved")
  exit MIQ_ABORT
end
