#
# cluster_deploy.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  environment = $evm.root['dialog_Environment']
  $evm.log(:info, "Environment: #{environment}") if @debug
  availability_zone = $evm.root['dialog_AvailabilityZone']
  $evm.log(:info, "AvailabilityZone: #{availability_zone}") if @debug
  cluster_identifier = $evm.root['dialog_ClusterIdentifier']
  $evm.log(:info, "ClusterIdentifier: #{cluster_identifier}") if @debug
  cluster_type = $evm.root['dialog_ClusterType']
  $evm.log(:info, "ClusterType: #{cluster_type}") if @debug
  db_name = $evm.root['dialog_DBname']
  $evm.log(:info, "DBname: #{db_name}") if @debug
  master_username = $evm.root['dialog_MasterUserName']
  $evm.log(:info, "MasterUserName: #{master_username}") if @debug
  master_userpassword = $evm.root['dialog_MasterUserPassword']
  $evm.log(:info, "MasterUserPassword: #{master_userpassword}") if @debug
  node_type = $evm.root['dialog_NodeType']
  $evm.log(:info, "NodeType: #{node_type}") if @debug
  application = $evm.root['dialog_Application']
  $evm.log(:info, "Application: #{application}") if @debug
  ticket = $evm.root['dialog_Ticket']
  $evm.log(:info, "Ticket: #{ticket}") if @debug
  shortcode = $evm.root['dialog_Shortcode']
  $evm.log(:info, "Shortcode: #{shortcode}") if @debug
  username = $evm.root['user'].userid.split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug
  
  #Call PScall method to run Deploy-RedshiftCluster-Sandbox.ps1 script
  $evm.log(:info, "Instantiating PowerShell call") if @debug
  #$evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  if cluster_type == 'false'
    $evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\AWSscripts\\Redshift\\Deploy-RedshiftCluster-Sandbox.ps1&value1=-env '#{environment}' -AvailabilityZone '#{availability_zone}' -ClusterIdentifier '#{cluster_identifier}' -ClusterType single-node -DBname '#{db_name}' -MasterUsername '#{master_username}' -MasterUserPassword '#{master_userpassword}' -NodeType '#{node_type}' -Name '#{cluster_identifier}' -Creator '#{username}' -Application '#{application}' -Ticket '#{ticket}' -Shortcode '#{shortcode}'")
    #$evm.root['param11'] = "powershell_cmd=C:\\vCO\\AWSscripts\\Redshift\\Deploy-RedshiftCluster-Sandbox.ps1 -env '#{environment}' -AvailabilityZone '#{availability_zone}' -ClusterIdentifier '#{cluster_identifier}' -ClusterType single-node -DBname '#{db_name}' -MasterUsername '#{master_username}' -MasterUserPassword '#{master_userpassword}' -NodeType '#{node_type}' -Name '#{cluster_identifier}' -Creator '#{username}' -Application '#{application}' -Ticket '#{ticket}' -Shortcode '#{shortcode}'"
  else
    $evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\AWSscripts\\Redshift\\Deploy-RedshiftCluster-Sandbox.ps1&value1=-env '#{environment}' -AvailabilityZone '#{availability_zone}' -ClusterIdentifier '#{cluster_identifier}' -ClusterType multi-node -DBname '#{db_name}' -MasterUsername '#{master_username}' -MasterUserPassword '#{master_userpassword}' -NodeType '#{node_type}' -Name '#{cluster_identifier}' -Creator '#{username}' -Application '#{application}' -Ticket '#{ticket}' -Shortcode '#{shortcode}'")
    #$evm.root['param11'] = "powershell_cmd=C:\\vCO\\AWSscripts\\Redshift\\Deploy-RedshiftCluster-Sandbox.ps1 -env '#{environment}' -AvailabilityZone '#{availability_zone}' -ClusterIdentifier '#{cluster_identifier}' -ClusterType multi-node -DBname '#{db_name}' -MasterUsername '#{master_username}' -MasterUserPassword '#{master_userpassword}' -NodeType '#{node_type}' -Name '#{cluster_identifier}' -Creator '#{username}' -Application '#{application}' -Ticket '#{ticket}' -Shortcode '#{shortcode}'"
  end
end
