#
# Description: This method checks to see if the VM has been removed from the provider
#

begin
  @debug = true
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  
  #Get server_name from dialog
  server_name = $evm.root['dialog_server_name']
  
  # Get vm object.
  vm = $evm.vmdb(:vm).find_by_name(server_name)
  exit MIQ_OK if vm.blank?

  $evm.root['ae_result'] = 'ok'
  
  if vm && $evm.get_state_var('vm_removed_from_provider')
    if vm.ext_management_system
      vm.refresh
      $evm.root['ae_result']     = 'retry'
      $evm.root['ae_retry_interval'] = '60.seconds'
    end
  end
end
