#
# lun_provisioning.rb
#
# Description: 
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  san_array = $evm.root['dialog_SANarray']
  $evm.log(:info, "SANarray: #{san_array}") if @debug
  sp = $evm.root['dialog_SP']
  $evm.log(:info, "SP: #{sp}") if @debug
  disk_type = $evm.root['dialog_DiskType']
  $evm.log(:info, "DiskType: #{disk_type}") if @debug
  pool = $evm.root['dialog_Pool']
  $evm.log(:info, "Pool: #{pool}") if @debug
  number_of_luns = $evm.root['dialog_NumberOfLUNs']
  $evm.log(:info, "NumberOfLUNs: #{number_of_luns}") if @debug
  lun_size = $evm.root['dialog_LUNsize']
  $evm.log(:info, "LUNsize: #{lun_size}") if @debug
  lun_name = $evm.root['dialog_LUNname']
  $evm.log(:info, "LUNname: #{lun_name}") if @debug
  cluster = $evm.root['dialog_Cluster']
  $evm.log(:info, "Cluster: #{cluster}") if @debug
  vcenter= $evm.root['dialog_option_1_vcenter']
  $evm.log(:info, "vCenter: #{vcenter}") if @debug
 
  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug

  #Call PScall method to run Find-VM.ps1 script
  #$evm.log(:info, "Instantiating PowerShell call") if @debug
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  if !lun_name
    #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\SAN\\LUN\\LunProvisioning.ps1&value1=-ArrayID '#{san_array}' -SP '#{sp}' -DiskType '#{disk_type}' -Pool '#{pool}' -NumberOfLUNs '#{number_of_luns}' -Cap '#{lun_size}' -Cluster '#{cluster}' -vCenter '#{vcenter}' -Replicated No -NTID '#{username}'")
    $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\SAN\\LUN\\LunProvisioning.ps1 -ArrayID '#{san_array}' -SP '#{sp}' -DiskType '#{disk_type}' -Pool '#{pool}' -NumberOfLUNs '#{number_of_luns}' -Cap '#{lun_size}' -Cluster '#{cluster}' -vCenter '#{vcenter}' -Replicated No -NTID '#{username}'"
  else   
    #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\SAN\\LUN\\LunProvisioning.ps1&value1=-ArrayID '#{san_array}' -SP '#{sp}' -DiskType '#{disk_type}' -Pool '#{pool}' -NumberOfLUNs '#{number_of_luns}' -Cap '#{lun_size}' -LUNname '#{lun_name}' -Cluster '#{cluster}' -vCenter '#{vcenter}' -Replicated No -NTID '#{username}'")
    $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\SAN\\LUN\\LunProvisioning.ps1 -ArrayID '#{san_array}' -SP '#{sp}' -DiskType '#{disk_type}' -Pool '#{pool}' -NumberOfLUNs '#{number_of_luns}' -Cap '#{lun_size}' -LUNname '#{lun_name}' -Cluster '#{cluster}' -vCenter '#{vcenter}' -Replicated No -NTID '#{username}'"
  end
end
