#
# app_creation.rb
#
# Description: Creates new Shiny application
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  long_name = $evm.root['dialog_long_name']
  $evm.log(:info, "App LongName: #{long_name}") if @debug
  short_name = $evm.root['dialog_short_name']
  $evm.log(:info, "App ShortName: #{short_name}") if @debug
  description = $evm.root['dialog_description']
  $evm.log(:info, "App Description: #{description}") if @debug
  business_owner = $evm.root['dialog_business_owner']
  $evm.log(:info, "App BusinessOwner: #{business_owner}") if @debug
  sensitive_data = $evm.root['dialog_sensitive_data']
  $evm.log(:info, "Sensitive Data: #{sensitive_data}") if @debug
  quantitative_access = $evm.root['dialog_access']
  $evm.log(:info, "Quantitative TeamAccess: #{quantitative_access}") if @debug
  it_supported = $evm.root['dialog_it_supported']
  $evm.log(:info, "It Supported: #{it_supported}") if @debug
  
  user_group = "shiny_#{short_name}_user"
  $evm.log(:info, "Shiny User Group: #{user_group}") if @debug
  
  # Quantitative Team Access
  if quantitative_access == 't' && sensitive_data == 't'
    quant_group = 'Enterprise Planning Quantitative Analysis'
    $evm.log(:info, "Quantitative Team Group: #{quant_group}") if @debug
  elsif quantitative_access == 't' && sensitive_data == 'f'
    quant_group = 'Enterprise Planning Quantitative Analysis'
    $evm.log(:info, "Quantitative Team Group: #{quant_group}") if @debug
  else
    quant_group1 = ''
  end
  
  # IT Supported Yes/No
  if it_supported == 't'
    it_supported = 'Yes'
  else
    it_supported = 'No'
  end
  $evm.log(:info, "It Supported: #{it_supported}")
  
  # Collect parameters to invoke Tower
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] = "app_long_name=#{long_name}"
  $evm.root['param12'] = "app_short_name=#{short_name}"
  $evm.root['param13'] = "description=#{description}"
  $evm.root['param14'] = "business_owner=#{business_owner}"
  $evm.root['param15'] = "it_supported=#{it_supported}" 
  $evm.root['param16'] = "user_group=#{user_group}"
  $evm.root['param17'] = "quant_group=#{quant_group}"
  $evm.root['param18'] = "Test=No"
  
  #Define State variables
  $evm.set_state_var(:app_name, "#{long_name}")
end
