#
# app_migration.rb
#
# Description: Creates new Shiny application
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  short_name = $evm.root['dialog_short_name']
  $evm.log(:info, "App ShortName: #{short_name}") if @debug
  long_name = $evm.root['dialog_long_name']
  $evm.log(:info, "App LongName: #{long_name}") if @debug
  target = $evm.root['dialog_target_location']
  $evm.log(:info, "Target Location: #{target}") if @debug

  # Non-IT Supported
  if target == 'Acceptance'
    source_server = 'shinywebd1.main.tva.gov'
    destination_server = 'shinyweba1.main.tva.gov'
  else
    source_server = 'shinyweba1.main.tva.gov'
    destination_server = 'shinywebp1.main.tva.gov'
  end
    
  $evm.log(:info, "Source Server: #{source_server}") if @debug
  $evm.log(:info, "Destination Server: #{destination_server}") if @debug
  # Collect parameters to launch Ansible Tower
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] = "app_short_name=#{short_name}"
  $evm.root['param12'] = "src_server=#{source_server}"
  $evm.root['param13'] = "dst_server=#{destination_server}"
    
  #Define State variables
  $evm.set_state_var(:app_name, "#{long_name}")
  $evm.set_state_var(:target, "#{target}")
  exit MIQ_OK 
end
