#
# creation_email.rb
#
# Description: <Method description here>
#
begin
  
  app_name = $evm.get_state_var(:app_name)
  
  userid = $evm.root['user'].userid
  $evm.log(:info, "UserID: #{userid}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/Email?userid=#{userid}") 
  raise 'Error instantiating PScall' if data.blank? 
  email = $evm.root['Email']
  $evm.log(:info, "Email: #{email}") if @debug
  
  if email
    to = email,$evm.object['to_email_address'] 
  else
    to = $evm.object['to_email_address']
  end

  # Get from_email_address from model unless specified below
  from = nil
  from ||= $evm.object['from_email_address']

  # Get signature from model unless specified below
  signature = nil
  signature ||= $evm.object['signature']
  
  # email subject
  subject = "Shiny App Creation: Sucessfully created #{app_name}"

  # Build email body
  body = "<font size='3' face='Calibri'>"
  body += "Cloudforms has sucessfully created new Shiny application <b>#{app_name}</b>."
 
  #
  # Send email
  #
  $evm.log("info", "Sending email to <#{to}> from <#{from}> subject: <#{subject}>")
  $evm.execute('send_email', to, from, subject, body)
end
