#
# create_snapshot.rb
#
# Description: Creates a Snapshot on requested VM
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  vCenter = $evm.root['dialog_option_1_vcenter']
  $evm.log(:info, "vCenter: #{vCenter}") if @debug
  machine = $evm.root['dialog_machine']
  $evm.log(:info, "machine: #{machine}") if @debug
  name = $evm.root['dialog_Name']
  $evm.log(:info, "name: #{name}") if @debug
  requestor = $evm.root['dialog_Requestor']
  $evm.log(:info, "requestor: #{requestor}") if @debug
 
  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug
  
  ntid = $evm.root['dialog_NTID']
  $evm.log(:info, "ntid: #{ntid}") if @debug
  
  #Call PScall method to run Create-VMwareSnapshot script
  #$evm.log(:info, "Instantiating PowerShell call") if @debug
  if requestor == 'Yes'
     #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\Snapshots\\Create-VMwareSnapshot.ps1&value1=-machine '#{machine}' -Name '#{name}' -Creator '#{username}' -NTID '#{ntid}'")
     $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Snapshots\\Create-VMwareSnapshot.ps1 -vCenter '#{vCenter}' -machine '#{machine}' -Name '#{name}' -Creator '#{username}' -NTID '#{ntid}'"
  else
     #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\Snapshots\\Create-VMwareSnapshot.ps1&value1=-machine '#{machine}' -Name '#{name}' -Creator '#{username}' -NTID '#{username}'")
     $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Snapshots\\Create-VMwareSnapshot.ps1 -vCenter '#{vCenter}' -machine '#{machine}' -Name '#{name}' -Creator '#{username}' -NTID '#{username}'"
  end
end
