#
# create_snapshot_admin.rb
#
# Description: Creates a Snapshot on requested VM
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug
  
  #Collect information from dialogs
  vCenter = $evm.root['dialog_option_1_vcenter']
  $evm.log(:info, "vCenter: #{vCenter}") if @debug
  machine = $evm.root['dialog_machine']
  $evm.log(:info, "machine: #{machine}") if @debug
  name = $evm.root['dialog_Name']
  $evm.log(:info, "Name: #{name}") if @debug
  ntid = $evm.root['dialog_ntid']
  $evm.log(:info, "NTID: #{ntid}") if @debug
  dnd = $evm.root['dialog_DND']
  $evm.log(:info, "DND: #{dnd}") if @debug
  date = $evm.root['dialog_DNDdate']
  $evm.log(:info, "Date: #{date}") if @debug
 
  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug
  
  #Call PScall method to run Create-VMwareSnapshot script
  #$evm.log(:info, "Instantiating PowerShell call") if @debug
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  if dnd == 'Yes'
     #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\Snapshots\\Create-VMwareSnapshot.ps1&value1=-machine '#{machine}' -Name '#{name}' -Creator '#{username}' -NTID '#{ntid}' -DNDdate '#{date}'")
     $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Snapshots\\Create-VMwareSnapshot.ps1 -vCenter '#{vCenter}' -machine '#{machine}' -Name '#{name}' -Creator '#{username}' -NTID '#{ntid}' -DNDdate '#{date}'"
  else
     #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\Snapshots\\Create-VMwareSnapshot.ps1&value1=-machine '#{machine}' -Name '#{name}' -Creator '#{username}' -NTID '#{ntid}'")
     $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Snapshots\\Create-VMwareSnapshot.ps1 -vCenter '#{vCenter}' -machine '#{machine}' -Name '#{name}' -Creator '#{username}' -NTID '#{ntid}'"
  end
end
