#
# update_snapshot.rb
#
# Description:
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  vCenter = $evm.root['dialog_option_1_vcenter']
  $evm.log(:info, "vCenter: #{vCenter}") if @debug
  machine = $evm.root['dialog_vm']
  $evm.log(:info, "machine: #{machine}") if @debug
  name = $evm.root['dialog_Name']
  $evm.log(:info, "Name: #{name}") if @debug
  date = $evm.root['dialog_DNDdate']
  $evm.log(:info, "Date: #{date}") if @debug
  dnd_date = Date.parse("#{date}").strftime("%m/%d/%Y")
 
  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug
  
  #Call PScall method to run Update-VMwareSnapshot.ps1 script
  #$evm.log(:info, "Instantiating PowerShell call") if @debug 
  #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\\Scripts\\Snapshots\\Update-VMwareSnapshot.ps1&value1=-machine '#{machine}' -Name '#{name}' -Creator '#{username}' -DNDdate '#{date}'")
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Snapshots\\Update-VMwareSnapshot.ps1 -vCenter '#{vCenter}' -machine '#{machine}' -Name '#{name}' -Creator '#{username}' -DNDdate '#{dnd_date}'"
end
