#
# gmsa_creation.rb
#
# Description:
#

begin
  @debug = true

  #Collect information from dialogs
  type = $evm.root['dialog_type']
  $evm.log(:info, "Type: #{type}") if @debug
  environment = $evm.root['dialog_environment']
  $evm.log(:info, "Environment: #{environment}") if @debug
  servers = $evm.root['dialog_servers']
  $evm.log(:info, "Servers: #{servers}") if @debug
  application = $evm.root['dialog_application']
  $evm.log(:info, "Application: #{application}") if @debug
 
  # Formats the servers variable as an array
  servers = "'#{servers.join("','")}'"
  
  # Gets the requestor's SamAccountName
  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug
  
  #Call PScall method to run Create-VMwareSnapshot script
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  if application
    $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Compute\\Windows\\GMSA\\New-GMSA.ps1 -Type '#{type}' -Environment '#{environment}' -Servers #{servers} -ApplicationName '#{application}' -NTID '#{username}'"
  else
    $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Compute\\Windows\\GMSA\\New-GMSA.ps1 -Type '#{type}' -Environment '#{environment}' -Servers #{servers} -NTID '#{username}'"
  end
end
