#
# sql_install.rb
#
# Description:
#

begin
  @debug = true
  #$evm.root.attributes.sort.each { |k, v| $evm.log(:info, "root: #{k}: #{v}") } if @debug

  #Collect information from dialogs
  server_name = $evm.root['dialog_server_name']
  $evm.log(:info, "ServerName: #{server_name}") if @debug
  change_id = $evm.root['dialog_change']
  $evm.log(:info, "Change Number: #{change_id}") if @debug
  sql_edition = $evm.root['dialog_sql_edition']
  $evm.log(:info, "SQL Edition: #{sql_edition}") if @debug
  sql_version = $evm.root['dialog_sql_version']
  $evm.log(:info, "SQl Version: #{sql_version}") if @debug
  failover = $evm.root['dialog_failover']
  $evm.log(:info, "Failover: #{failover}") if @debug
  sql_username = $evm.root['dialog_sql_username']
  $evm.log(:info, "SQl Username: #{sql_username}") if @debug
  sql_password = $evm.root.decrypt('dialog_sql_password')
  $evm.log(:info, "SQl Password: #{sql_password}") if @debug
   
  email = $evm.root['user'].userid
  $evm.log(:info, "Email: #{email}") if @debug    
  data = $evm.instantiate("/Integration/DynamicDialogs/LDAPDialogs/ntid?email=#{email}") 
  raise 'Error instantiating PScall' if data.blank? 
  username = $evm.root['userid'].split('@').first.split('-').first
  $evm.log(:info, "Username: #{username}") if @debug
  
 
  #Call PScall method to run Set-TVAAppPool.ps1 script
  #$evm.log(:info, "Instantiating PowerShell call") if @debug
  #$evm.instantiate("/Integration/CommonMethods/Powershell/PScall?script=C:\\vCO\Scripts\\Compute\\WindowsServerDeploy\\SQLInstall.ps1 -Name'#{server_name}' -ChangeID '#{change_id}' -SQLVersion '#{sql_version}' -SQLEdition '#{sql_edition}' -SQLUsername '#{sql_username}' -SQlPassword '#{sql_password}' -Failover '#{failover}' -NTID '#{username}'")
  $evm.log(:info, "Collecting parameters to launch Ansible Tower") if @debug
  $evm.root['param11'] = "powershell_cmd=C:\\vCO\\Scripts\\Compute\\WindowsServerDeploy\\WindowsSQLInstall.ps1 -Name '#{server_name}' -ChangeID '#{change_id}' -SQLVersion '#{sql_version}' -SQLEdition '#{sql_edition}' -SQLUsername '#{sql_username}' -SQlPassword '#{sql_password}' -Failover '#{failover}' -NTID '#{username}'"
end
